import type { WTCGLRenderingContext } from '../types';
import { Program } from './Program';
export interface TransformFeedbackAttribute {
    size: number;
    type?: GLenum;
    normalize?: boolean;
    stride?: number;
    offset?: number;
    buffer?: WebGLBuffer;
    data: Float32Array;
    varying: string;
    usage?: GLenum;
    buffertype?: GLenum;
}
export interface TransformFeedbackOptions {
    program: Program;
    transformFeedbacks: {
        [key: string]: TransformFeedbackAttribute;
    };
}
export type BufferRef = {
    i: number;
    buffer: WebGLBuffer | null;
};
export type BufferRecord = Record<string, BufferRef>;
/**
 * To-Do
 * Update this class to take care of its own internal state (like render targets) rather than relying on geo to control state
 */
export declare class TransformFeedback {
    VAOs: [WebGLVertexArrayObject, WebGLVertexArrayObject];
    TFBs: [WebGLTransformFeedback, WebGLTransformFeedback];
    BufferRefs: BufferRecord[];
    constructor(gl: WTCGLRenderingContext, { program, transformFeedbacks }: TransformFeedbackOptions);
}
