import type { WTCGLRenderingContext } from '../types';
import type { Renderer, RenderOptions } from '../core/Renderer';
import { RenderTarget } from '../core/RenderTarget';
export interface FramebufferOptions {
    name: string;
    width: number;
    height: number;
    dpr: number;
    tiling: number;
    texdepth: number;
    minFilter: GLenum;
    magFilter: GLenum;
    premultiplyAlpha: boolean;
    data: Float32Array | null;
    depth: boolean;
}
export declare class Framebuffer {
    #private;
    static TEXTYPE_FLOAT: number;
    static TEXTYPE_UNSIGNED_BYTE: number;
    static TEXTYPE_HALF_FLOAT_OES: number;
    static IMAGETYPE_REGULAR: number;
    static IMAGETYPE_TILING: number;
    static IMAGETYPE_MIRROR: number;
    gl: WTCGLRenderingContext;
    name: string;
    depth: boolean;
    minFilter: number;
    magFilter: number;
    premultiplyAlpha: boolean;
    constructor(gl: WTCGLRenderingContext, { name, width, height, dpr, tiling, texdepth, minFilter, magFilter, premultiplyAlpha, data, depth }?: Partial<FramebufferOptions>);
    resize(width: number, height: number): void;
    createFrameBuffer(): RenderTarget;
    swap(): void;
    render(renderer: Renderer, { scene, camera, update, clear, viewport }: RenderOptions): void;
    get wrap(): 33071 | 10497 | 33648 | undefined;
    get type(): number | undefined;
    get read(): RenderTarget;
    get write(): RenderTarget;
    set data(value: Float32Array | null);
    get data(): Float32Array | null;
    set width(value: number);
    get width(): number;
    set height(value: number);
    get height(): number;
    set pxRatio(value: number);
    get pxRatio(): number;
    set dpr(value: number);
    get dpr(): number;
    set tiling(value: number);
    get tiling(): number;
    set texdepth(value: number);
    get texdepth(): number;
}
