import { Vec2 } from 'wtc-math';
import type { WTCGLRenderingContext, WTCGLUniformArray } from '../../types';
import type { Framebuffer } from '../../ext/Framebuffer';
import { Renderer } from '../../core/Renderer';
import { Program } from '../../core/Program';
import { Mesh } from '../../core/Mesh';
import { Uniform } from '../../core/Uniform';
export interface FragmentShaderOptions {
    vertex: string;
    fragment: string;
    dimensions: Vec2;
    container: HTMLElement;
    autoResize: boolean;
    uniforms: WTCGLUniformArray;
    onInit: (renderer: Renderer) => void;
    onBeforeRender: (delta: number) => void;
    onAfterRender: (delta: number) => void;
    rendererProps: object;
}
export declare class FragmentShader {
    #private;
    uniforms: WTCGLUniformArray;
    dimensions: Vec2;
    autoResize: boolean;
    onBeforeRender: (t: number) => void;
    onAfterRender: (t: number) => void;
    u_time: Uniform;
    u_resolution: Uniform;
    gl: WTCGLRenderingContext;
    renderer: Renderer;
    program: Program;
    mesh: Mesh;
    lastTime: number;
    constructor({ vertex, fragment, dimensions, container, autoResize, uniforms, onInit, onBeforeRender, onAfterRender, rendererProps }?: Partial<FragmentShaderOptions>);
    resize(): void;
    resetTime(): void;
    render(t: number): void;
    set post(p: Framebuffer);
    get post(): Framebuffer;
    set playing(v: boolean);
    get playing(): boolean;
}
