var yt = Object.defineProperty;
var Mt = (d, t, e) => t in d ? yt(d, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : d[t] = e;
var i = (d, t, e) => (Mt(d, typeof t != "symbol" ? t + "" : t, e), e), ut = (d, t, e) => {
  if (!t.has(d))
    throw TypeError("Cannot " + e);
};
var A = (d, t, e) => (ut(d, t, "read from private field"), e ? e.call(d) : t.get(d)), S = (d, t, e) => {
  if (t.has(d))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(d) : t.set(d, e);
}, y = (d, t, e, s) => (ut(d, t, "write to private field"), s ? s.call(d, e) : t.set(d, e), e);
import { Mat4 as O, Vec3 as p, Quat as st, Vec2 as M, Mat3 as dt } from "wtc-math";
class At {
  /**
   * Create an object. Normally only called from an extending class.
   */
  constructor() {
    /**
     * The parent of this object.
     */
    i(this, "parent");
    /**
     * The children of this object
     */
    i(this, "children");
    /**
     * Whether this objec is visible or not. This will stop the renderer from trying to render this object
     */
    i(this, "visible");
    /**
     * A matrix representing the translation, rotation and scale of this object.
     */
    i(this, "matrix");
    /**
     * The world matrix represents the function of all ancestor matrices and the matrix of this object
     */
    i(this, "worldMatrix");
    /**
     * Whether to automatically calculate the object matrix each time updateWorldMatrix is called. Convenient, but potentially costly.
     */
    i(this, "matrixAutoUpdate");
    /**
     * A boolean indicating whether the world matrix requires updating.
     */
    i(this, "worldMatrixNeedsUpdate", !1);
    /**
     * Object position
     */
    i(this, "position");
    /**
     * Object rotation, expressed as a quaternion
     */
    i(this, "quaternion");
    /**
     * Object scale
     */
    i(this, "scale");
    /**
     * Object rotation, expressed as a 3D Euler rotation
     */
    i(this, "rotation");
    /**
     * The up unit vector
     */
    i(this, "up");
    this.parent = null, this.children = [], this.visible = !0, this.matrix = new O(), this.worldMatrix = new O(), this.matrixAutoUpdate = !0, this.position = new p(), this.quaternion = new st(), this.scale = new p(1, 1, 1), this.rotation = new p(), this.up = new p(0, 1, 0);
  }
  /**
   * UpdateRotation should be called whenever a change to the rotation variable is made. This will update the quaternion in response to the change in the rotation.
   * For example:
   * ```js
   * const Box = new Mesh(gl, { geometry: BoxGeo, program });
   * Box.rotation.x = Math.PI*.25;
   * Box.updateRotation();
   * console.log(Box.quaternion) // {_x: 0.3826834323650898, _y: 0, _z: 0, _w: 0.9238795325112867}
   * ```
   */
  updateRotation() {
    this.quaternion = st.fromEuler(this.rotation) || new st();
  }
  /**
   * UpdateRotation should be called whenever a change to the quaternion variable is made. This will update the rotation in response to the change in the quaternion.
   * For example:
   * ```js
   * const Box = new Mesh(gl, { geometry: BoxGeo, program });
   * Box.quaternion = Quat.fromAxisAngle(new Vec3(1,0,0), Math.PI*-.25);
   * Box.updateQuaternion();
   * console.log(Box.rotation) // {_x: 0.7853981633974483, _y: 0, _z: 0}
   * ```
   */
  updateQuaternion() {
    const t = O.fromQuat(this.quaternion);
    this.rotation = p.fromRotationMatrix(t) || new p();
  }
  /**
   * Sets the parent of this object and indicates whether to set a child relationship on the parent.
   * @param parent - The parent object to use
   * @param notifyParent - Whether to set the full parent-child relationsjip
   */
  setParent(t, e = !0) {
    this.parent && t !== this.parent && this.parent.removeChild(this, !1), this.parent = t, e && t && t.addChild(this, !1);
  }
  /**
   * Adds a child object to this and indicates whether to notify the child
   * @param child - The object to add as a child of this one
   * @param notifyChild - Whether to set the parent of the indicated child to this
   */
  addChild(t, e = !0) {
    ~this.children.indexOf(t) || this.children.push(t), e && t.setParent(this, !1);
  }
  /**
   * Remove a child from this object.
   * @param child - The child to remove
   * @param notifyChild - Whether to notify the child of the removal
   */
  removeChild(t, e = !0) {
    ~this.children.indexOf(t) && this.children.splice(this.children.indexOf(t), 1), e && t.setParent(null, !1);
  }
  /**
   * Update the fill world matrix of this object basically used for recursively looping down the hierarchy when a change in the RTS matrix is changed on this.
   * @param force Even is this is not set to world matrix update, force it. Used when looping down past the first iteration.
   */
  updateMatrixWorld(t) {
    this.matrixAutoUpdate && this.updateMatrix(), (this.worldMatrixNeedsUpdate || t) && (this.parent === null || this.parent === void 0 ? this.worldMatrix = this.matrix.clone() : this.worldMatrix = this.parent.worldMatrix.multiplyNew(this.matrix), this.worldMatrixNeedsUpdate = !1, t = !0);
    for (let e = 0, s = this.children.length; e < s; e++)
      this.children[e].updateMatrixWorld(t);
  }
  /**
   * Updates the object matrix based on the rotation, translation and scale , then runs an update.
   */
  updateMatrix() {
    this.matrix = O.fromRotationTranslationScale(
      this.quaternion,
      this.position,
      this.scale
    ), this.worldMatrixNeedsUpdate = !0;
  }
  /**
   * Traverses the object tree and runs a given function against the object. If true is returned, the traversal is stopped.
   * This is useful for testing things like visibility etc.
   * @param callback - The function to call, it should return true or null based on some condition
   */
  traverse(t) {
    if (!t(this))
      for (let e = 0, s = this.children.length; e < s; e++)
        this.children[e].traverse(t);
  }
  /**
   * Decomposes the object matrix into the various components necessary to populate this object.
   */
  decompose() {
    this.position = this.matrix.translation, this.quaternion = this.matrix.rotation, this.scale = this.matrix.scaling;
    const t = O.fromQuat(this.quaternion);
    this.rotation = p.fromRotationMatrix(t) || new p();
  }
  /**
   * Makes the object look at a particular target, useful for cameras
   * @param target - The point to look at
   * @param invert - Look away from, if true
   */
  lookAt(t, e = !1) {
    e ? this.matrix = O.targetTo(this.position, t, this.up) : this.matrix = O.targetTo(t, this.position, this.up), this.quaternion = this.matrix.rotation;
    const s = O.fromQuat(this.quaternion);
    this.rotation = p.fromRotationMatrix(s) || new p(), this.updateRotation();
  }
}
let Rt = 0;
class wt extends At {
  /**
   * Create a drawable object. This should never be instanciated directly
   * @param {WTCGLRenderingContext} gl - The WTCGL Rendering context
   * @param {Object} __namedParameters - The parameters to be used for the camera
   * @param {boolean} frustumCulled - Whether to apply culling to this object
   * @param {number} renderOrder - The explicit render order of the object. If this is zero, then it will be instead calculated at render time.
   */
  constructor(e, { frustumCulled: s = !0, renderOrder: r = 0 } = {}) {
    super();
    /**
     * The unique ID of the Geometry.
     */
    i(this, "id");
    /**
     * The WTCGL rendering context.
     */
    i(this, "gl");
    /**
     * The program that is rendering this object
     */
    i(this, "program");
    /**
     * Whether to apply frustum culling to this object
     * @default true
     */
    i(this, "frustumCulled");
    /**
     * Apply a specific render order, overriding calculated z-depth
     * @default 0
     */
    i(this, "renderOrder", 0);
    /**
     * The z-depth of the object, calculated at render time.
     * @default 0
     */
    i(this, "zDepth", 0);
    e.canvas || console.error(
      "WTCGLRenderingContext should be passed as the first argument to Object"
    ), this.gl = e, this.id = Rt++, this.frustumCulled = s, this.renderOrder = r;
  }
  /**
   * Draw placeholder. The draw function is responsible for drawing the element. This function simply provides a signature for extension.
   **/
  // eslint-disable-next-line @typescript-eslint/no-unused-vars, @typescript-eslint/no-explicit-any
  draw(...e) {
  }
}
var X;
class bt {
  /**
   * create a renderer
   * @param __namedParameters - The parameters to initialise the renderer.
   * @param canvas - The canvas HTML element to render to.
   * @param width - The width of the canvas.
   * @param height - The height of the canvas.
   * @param dpr - The pixel aspect ratio of the canvas.
   * @param alpha - Whether to render an alpha channel.
   * @param depth - Whether to render a depth buffer.
   * @param stencil - Whether to render a stencil buffer.
   * @param premultipliedAlpha - Whether to use premultiplied alpha.
   * @param preserveDrawingBuffer - Preserve the drawing buffer between calls. Useful for when downloading the canvas to an image.
   * @param powerPreference - WebGL power preference.
   * @param autoClear - Whether to clear the canvas between draw.
   * @param webgl - The webGL version to try to use - 1, or 2
   */
  constructor({
    canvas: t = document.createElement("canvas"),
    width: e = 300,
    height: s = 150,
    dpr: r = Math.min(window.devicePixelRatio, 2),
    alpha: a = !1,
    depth: n = !0,
    stencil: u = !1,
    antialias: o = !1,
    premultipliedAlpha: h = !1,
    preserveDrawingBuffer: l = !1,
    powerPreference: c = "default",
    autoClear: f = !0,
    webgl: g = 2
  } = {}) {
    /**
     * The pixel aspect ratio of the renderer.
     * @default window.devicePixelRatio or 2, whichever is smaller.
     */
    i(this, "dpr");
    /**
     * The dimensions of the renderer
     */
    S(this, X, void 0);
    /**
     * Whether to render an alpha channel. This property is passed to the rendering context.
     * @default false
     */
    i(this, "alpha");
    /**
     * Whether to clear the color bit
     * @default true
     */
    i(this, "colour");
    /**
     * Whether to render a depth buffer. This property is passed to the rendering context.
     * @default true
     */
    i(this, "depth");
    /**
     * Whether to render a stencil buffer. This property is passed to the rendering context.
     * @default false
     */
    i(this, "stencil");
    /**
     * Whether to use premultiplied alphs. This property is passed to the rendering context.
     * @default false
     */
    i(this, "premultipliedAlpha");
    /**
     * Whether to automatically clear the buffers before render.
     * @default true
     */
    i(this, "autoClear");
    /**
     * Whether the context we've retrieved is webGL2 or not.
     */
    i(this, "isWebgl2");
    /**
     * The WTCGL rendering context.
     */
    i(this, "gl");
    /**
     * The rendering state. Allows us to avoid redundant calls on methods used internally
     */
    i(this, "state");
    /**
     * Stores the enabled extensions
     */
    i(this, "extensions");
    /**
     * Stored device parameters such as max allowable units etc.
     */
    i(this, "parameters");
    /**
     * Stores the current geometry being rendered. Used to otimise geo rendering.
     */
    i(this, "currentGeometry");
    /**
     * The WebGL2RenderingContext.vertexAttribDivisor() method of the WebGL 2 API modifies the rate at which generic vertex attributes advance when rendering multiple instances of primitives with
     */
    i(this, "vertexAttribDivisor");
    /**
     * The WebGL2RenderingContext.drawArraysInstanced() method of the WebGL 2 API renders primitives from array data like the gl.drawArrays() method. In addition, it can execute multiple instances of the range of elements.
     */
    i(this, "drawArraysInstanced");
    /**
     * The WebGL2RenderingContext.drawElementsInstanced() method of the WebGL 2 API renders primitives from array data like the gl.drawElements() method. In addition, it can execute multiple instances of a set of elements.
     */
    i(this, "drawElementsInstanced");
    /**
     * The WebGL2RenderingContext.createVertexArray() method of the WebGL 2 API creates and initializes a WebGLVertexArrayObject object that represents a vertex array object (VAO) pointing to vertex array data and which provides names for different sets of vertex data.
     */
    i(this, "createVertexArray");
    /**
     * The WebGL2RenderingContext.bindVertexArray() method of the WebGL 2 API binds a passed WebGLVertexArrayObject object to the buffer.
     */
    i(this, "bindVertexArray");
    /**
     * The WebGL2RenderingContext.deleteVertexArray() method of the WebGL 2 API deletes a given WebGLVertexArrayObject object.
     */
    i(this, "deleteVertexArray");
    /**
     * The WebGL2RenderingContext.drawBuffers() method of the WebGL 2 API defines draw buffers to which fragment colors are written into. The draw buffer settings are part of the state of the currently bound framebuffer or the drawingbuffer if no framebuffer is bound.
     */
    i(this, "drawBuffers");
    // Allows programs to optimise by determine if they're the currently rendering program and skipping some steps
    i(this, "currentProgram");
    const x = {
      alpha: a,
      depth: n,
      stencil: u,
      antialias: o,
      premultipliedAlpha: h,
      preserveDrawingBuffer: l,
      powerPreference: c
    };
    if (this.dpr = r, this.alpha = a, this.colour = !0, this.depth = n, this.stencil = u, this.premultipliedAlpha = h, this.autoClear = f, g === 2 && (this.gl = t.getContext("webgl2", x)), this.isWebgl2 = !!this.gl, this.gl || (this.gl = t.getContext("webgl", x)), !this.gl)
      return console.error("unable to create webgl context"), this;
    this.gl.renderer = this, this.dimensions = new M(e, s), this.state = {
      blendFunc: { src: this.gl.ONE, dst: this.gl.ZERO },
      blendEquation: {
        modeRGB: this.gl.FUNC_ADD,
        modeAlpha: this.gl.ONE_MINUS_SRC_ALPHA
      },
      cullFace: null,
      frontFace: this.gl.CCW,
      depthMask: !0,
      depthFunc: this.gl.LESS,
      premultiplyAlpha: !1,
      flipY: !1,
      unpackAlignment: 4,
      framebuffer: null,
      viewport: { width: null, height: null, x: 0, y: 0 },
      textureUnits: [],
      activeTextureUnit: 0,
      boundBuffer: null,
      uniformLocations: /* @__PURE__ */ new Map()
    }, this.extensions = {}, this.isWebgl2 ? (this.getExtension("EXT_color_buffer_float"), this.getExtension("OES_texture_float_linear"), this.getExtension("OES_standard_derivatives")) : (this.getExtension("OES_texture_float"), this.getExtension("OES_texture_float_linear"), this.getExtension("OES_texture_half_float"), this.getExtension("OES_texture_half_float_linear"), this.getExtension("OES_element_index_uint"), this.getExtension("OES_standard_derivatives"), this.getExtension("EXT_sRGB"), this.getExtension("WEBGL_depth_texture"), this.getExtension("WEBGL_draw_buffers")), this.vertexAttribDivisor = this.getExtension(
      "ANGLE_instanced_arrays",
      "vertexAttribDivisor",
      "vertexAttribDivisorANGLE"
    ), this.drawArraysInstanced = this.getExtension(
      "ANGLE_instanced_arrays",
      "drawArraysInstanced",
      "drawArraysInstancedANGLE"
    ), this.drawElementsInstanced = this.getExtension(
      "ANGLE_instanced_arrays",
      "drawElementsInstanced",
      "drawElementsInstancedANGLE"
    ), this.createVertexArray = this.getExtension(
      "OES_vertex_array_object",
      "createVertexArray",
      "createVertexArrayOES"
    ), this.bindVertexArray = this.getExtension(
      "OES_vertex_array_object",
      "bindVertexArray",
      "bindVertexArrayOES"
    ), this.deleteVertexArray = this.getExtension(
      "OES_vertex_array_object",
      "deleteVertexArray",
      "deleteVertexArrayOES"
    ), this.drawBuffers = this.getExtension(
      "WEBGL_draw_buffers",
      "drawBuffers",
      "drawBuffersWEBGL"
    ), this.parameters = {
      maxTextureUnits: this.gl.getParameter(
        this.gl.MAX_COMBINED_TEXTURE_IMAGE_UNITS
      ),
      maxAnisotropy: this.getExtension("EXT_texture_filter_anisotropic") ? this.gl.getParameter(
        this.getExtension("EXT_texture_filter_anisotropic").MAX_TEXTURE_MAX_ANISOTROPY_EXT
      ) : 0
    };
  }
  set dimensions(t) {
    y(this, X, t), this.gl.canvas.width = t.width * this.dpr, this.gl.canvas.height = t.height * this.dpr;
  }
  get dimensions() {
    return A(this, X);
  }
  /**
   * Set up the viewport for rendering.
   * @param dimensions - The dimensions of the viewport
   * @param position - The position of the viewport
   */
  setViewport(t, e) {
    this.state.viewport.width === t.width && this.state.viewport.height === t.height && this.state.viewport.x === e.x && this.state.viewport.y === e.y || (this.state.viewport.width = t.width, this.state.viewport.height = t.height, this.state.viewport.x = e.x, this.state.viewport.y = e.y, this.gl.viewport(
      e.x,
      e.y,
      t.width,
      t.height
    ));
  }
  /**
   * Enables specific WebGL capabilities for this context.
   * See [MDN](https://developer.mozilla.org/en-US/docs/Web/API/WebGLRenderingContext/enable) for more details
   * @param id - The ID of the capability to enable
   */
  enable(t) {
    this.state[t] !== !0 && (this.gl.enable(t), this.state[t] = !0);
  }
  /**
   * Disables specific WebGL capabilities for this context.
   * @param id - The ID of the capability to enable
   */
  disable(t) {
    this.state[t] !== !1 && (this.gl.disable(t), this.state[t] = !1);
  }
  /**
   * Set's various blend functions are used for blending pixel calculations
   * See [MDN](https://developer.mozilla.org/en-US/docs/Web/API/WebGLRenderingContext/blendFunc) for more details
   * If alpha functions are provided, this will call gl.blendFuncSeparate, otherwise blendFunc
   * @param src - A WebGL_API.Types specifying a multiplier for the RGB source blending factors.
   * @param dst - A WebGL_API.Types specifying a multiplier for the RGB destination blending factors.
   * @param srcAlpha - A WebGL_API.Types specifying a multiplier for the alpha source blending factor.
   * @param dstAlpha - A WebGL_API.Types specifying a multiplier for the alpha destination blending factor.
   */
  setBlendFunc(t, e, s, r) {
    this.state.blendFunc.src === t && this.state.blendFunc.dst === e && this.state.blendFunc.srcAlpha === s && this.state.blendFunc.dstAlpha === r || (this.state.blendFunc.src = t, this.state.blendFunc.dst = e, this.state.blendFunc.srcAlpha = s, this.state.blendFunc.dstAlpha = r, s !== void 0 && r !== void 0 ? this.gl.blendFuncSeparate(t, e, s, r) : this.gl.blendFunc(t, e));
  }
  /**
   * Sets a blending function for use in the application.
   * See [MDN](https://developer.mozilla.org/en-US/docs/Web/API/WebGLRenderingContext/blendEquation) for more information
   * @param modeRGB - The function to be used in RGB models
   * @param modeAlpha - The functions to be used for both RGB and alpha models
   */
  setBlendEquation(t, e) {
    t = t || this.gl.FUNC_ADD, !(this.state.blendEquation.modeRGB === t && this.state.blendEquation.modeAlpha === e) && (this.state.blendEquation.modeRGB = t, this.state.blendEquation.modeAlpha = e, e !== void 0 ? this.gl.blendEquationSeparate(t, e) : this.gl.blendEquation(t));
  }
  /**
   * Sets the cull face bit
   */
  set cullFace(t) {
    this.state.cullFace !== t && (this.state.cullFace = t, this.gl.cullFace(t));
  }
  get cullFace() {
    return this.state.cullFace;
  }
  /**
   * Sets the front face bit
   */
  set frontFace(t) {
    this.state.frontFace !== t && (this.state.frontFace = t, this.gl.frontFace(t));
  }
  get frontFace() {
    return this.state.frontFace;
  }
  /**
   * Sets the depth mask bit
   */
  set depthMask(t) {
    this.state.depthMask !== t && (this.state.depthMask = t, this.gl.depthMask(t));
  }
  get depthMask() {
    return this.state.depthMask;
  }
  /**
   * Sets the depth function bit
   */
  set depthFunc(t) {
    this.state.depthFunc !== t && (this.state.depthFunc = t, this.gl.depthFunc(t));
  }
  get depthFunc() {
    return this.state.depthFunc;
  }
  /**
   * Sets the active texture value
   */
  set activeTexture(t) {
    this.state.activeTextureUnit !== t && (this.state.activeTextureUnit = t, this.gl.activeTexture(this.gl.TEXTURE0 + t));
  }
  get activeTexture() {
    return this.state.activeTextureUnit;
  }
  /**
   * Binds a given WebGLFramebuffer to a target .
   * @param __namedParameters
   * @param target - A GLenum specifying the binding point (target). Typically only `gl.FRAMEBUFFER` see [MDN](https://developer.mozilla.org/en-US/docs/Web/API/WebGLRenderingContext/bindFramebuffer) for more information
   * @param buffer - A WebGLFramebuffer object to bind. If framebuffer is null, then the canvas (which has no WebGLFramebuffer object) is bound.
   * @returns
   */
  bindFramebuffer({
    target: t = this.gl.FRAMEBUFFER,
    buffer: e = null
  } = {}) {
    this.state.framebuffer !== e && (this.state.framebuffer = e, this.gl.bindFramebuffer(t, e));
  }
  /**
   * Finds and enables a webGL extension and, if it has a corresponding function, returns that.
   * @param extension - The extension identifier.
   * @param webgl2Func -The name of the webGL2 function to return.
   * @param extFunc - The name of the webGL1 functiont to return.
   * @returns - A WebGL function, bound to this renderer or null (if no function exists)
   */
  getExtension(t, e, s) {
    const r = e;
    if (e && this.gl[r]) {
      const n = this.gl[r];
      return typeof n == "function" ? n.bind(this.gl) : n;
    }
    const a = t;
    if (this.extensions[a] || (this.extensions[a] = this.gl.getExtension(t)), !e)
      return this.extensions[a];
    if (!this.extensions[a])
      return null;
    if (s) {
      const n = this.extensions[a], u = n == null ? void 0 : n[s];
      if (u)
        return u.bind(n);
    }
  }
  /**
   * An array sort for opaque elements
   * @param a - A renderable object for sorting
   * @param b - A renderable object for sorting
   * @returns The number to determine relative position
   */
  sortOpaque(t, e) {
    return t.renderOrder !== e.renderOrder ? t.renderOrder - e.renderOrder : t.program.id !== e.program.id ? t.program.id - e.program.id : t.zDepth !== e.zDepth ? t.zDepth - e.zDepth : e.id - t.id;
  }
  /**
   * An array sort for transparent elements
   * @param a - A renderable object for sorting
   * @param b - A renderable object for sorting
   * @returns The number to determine relative position
   */
  sortTransparent(t, e) {
    return t.renderOrder !== e.renderOrder ? t.renderOrder - e.renderOrder : t.zDepth !== e.zDepth ? e.zDepth - t.zDepth : e.id - t.id;
  }
  /**
   * An array sort for UI (no depth) elements
   * @param a - A renderable object for sorting
   * @param b - A renderable object for sorting
   * @returns The number to determine relative position
   */
  sortUI(t, e) {
    return t.renderOrder !== e.renderOrder ? t.renderOrder - e.renderOrder : t.program.id !== e.program.id ? t.program.id - e.program.id : e.id - t.id;
  }
  /**
   * Retrieves the list of renderable objects sorted by position, explicit render order and applied depth
   * @param __namedParameters
   * @param scene - The root scene to render.
   * @param camera - The camera to use to determine the render list, applies frustum culling etc.
   * @param frustumCull - Whether to apply frustum culling
   * @param sort - Whether to sort the list at all.
   * @returns - An array of renderable objects
   */
  getRenderList({
    scene: t,
    camera: e,
    frustumCull: s,
    sort: r
  }) {
    let a = [];
    if (e && s && e.updateFrustum(), t.traverse((n) => n.visible ? (!(n instanceof wt) || s && n.frustumCulled && e && !e.frustumIntersects(n) || a.push(n), null) : !0), r) {
      const n = [], u = [], o = [];
      a.forEach((h) => {
        const { program: l } = h;
        if (l ? l.transparent ? l.depthTest && u.push(h) : n.push(h) : o.push(h), h.renderOrder !== 0 || !l.depthTest || !e)
          return;
        const c = h.worldMatrix.translation;
        c.transformByMat4(e.projectionViewMatrix), h.zDepth = c.z;
      }), n.sort(this.sortOpaque), u.sort(this.sortTransparent), o.sort(this.sortUI), a = n.concat(u, o);
    }
    return a;
  }
  /**
   * Renders a scene
   * @param __namedParameters
   * @param scene - The renderable object to render.
   * @param camera - The camera to render with. If not supplied will just render as is.
   * @param target - The render target to render to.
   * @param update - Whether to update all of the object worl matrices prior to rendering.
   * @param sort - Whether to sort the objects prior to rendering.
   * @param frustumCull - Whether to apply frustum culling prior to rendering.
   * @param clear - Whether to clear the scene prior to rendering. Only matters if renderer.autoClear is false.
   */
  render({
    scene: t,
    camera: e,
    target: s = null,
    update: r = !0,
    sort: a = !0,
    frustumCull: n = !0,
    clear: u,
    viewport: o
  }) {
    s === null ? (this.bindFramebuffer(), o || (o = [this.dimensions.scaleNew(this.dpr), new M()]), this.setViewport(...o)) : (this.bindFramebuffer(s), o || (o = [new M(s.width, s.height), new M()]), this.setViewport(...o)), (u || this.autoClear && u !== !1) && (this.depth && (!s || s.depth) && (this.enable(this.gl.DEPTH_TEST), this.depthMask = !0), this.gl.clear(
      (this.colour ? this.gl.COLOR_BUFFER_BIT : 0) | (this.depth ? this.gl.DEPTH_BUFFER_BIT : 0) | (this.stencil ? this.gl.STENCIL_BUFFER_BIT : 0)
    )), r && t.updateMatrixWorld(), e && e.updateMatrixWorld(), this.getRenderList({ scene: t, camera: e, frustumCull: n, sort: a }).forEach((l) => {
      l.draw({ camera: e });
    });
  }
}
X = new WeakMap();
const ct = new Uint8Array(4);
function ft(d) {
  return (d & d - 1) === 0;
}
let Ft = 1;
class V {
  /**
   * Create a render target object.
   * @param {WTCGLRenderingContext} gl - The WTCGL Rendering context
   * @param __namedParameters - The parameters to initialise the renderer.
   * @param target - The binding point for the frame buffers.
   * @param type - The texture type. Typically one of gl.UNSIGNED_BYTE, gl.FLOAT, ext.HALF_FLOAT_OES
   * @param format - The texture format.
   * @param internalFormat - the texture internalFormat.
   * @param wrapS - Wrapping
   * @param wrapT - Wrapping
   * @param generateMipmaps - Whether to generate mips for this texture
   * @param minFilter - The filter to use when rendering smaller
   * @param magFilter - The filter to use when enlarging
   * @param premultiplyAlpha - Whether to use premultiplied alpha for stored textures.
   * @param flipY - Whether to flip the Y component of the supplied image
   * @param anistropy - The anistropic filtering level for the texture.
   * @param unpackAlignment - The unpack alignment for pixel stores.
   * @param level - A GLint specifying the level of detail. Level 0 is the base image level and level n is the nth mipmap reduction level. Only relevant if we have mipmaps.
   * @param width - The width of the render target.
   * @param height - The height of the render target.
   */
  constructor(t, {
    image: e,
    data: s,
    target: r = t.TEXTURE_2D,
    type: a = t.UNSIGNED_BYTE,
    format: n = t.RGBA,
    internalFormat: u = n,
    wrapS: o = t.CLAMP_TO_EDGE,
    wrapT: h = t.CLAMP_TO_EDGE,
    generateMipmaps: l = !0,
    minFilter: c = l ? t.NEAREST_MIPMAP_LINEAR : t.LINEAR,
    magFilter: f = t.LINEAR,
    premultiplyAlpha: g = !1,
    unpackAlignment: x = 4,
    flipY: m = r == t.TEXTURE_2D,
    anisotropy: T = 0,
    level: _ = 0,
    width: E,
    // used for RenderTargets or Data Textures
    height: w = E
  } = {}) {
    /**
     * A unique ID for the texture object, allows us to determine whether a texture has already been bound or not.
     */
    i(this, "id");
    /**
     * The WTCGL rendering context.
     */
    i(this, "gl");
    /**
     * The image element representing the texture. Can be an HTML image, video, or canvas
     */
    i(this, "image");
    i(this, "data");
    /**
     * The WebGL texture object containing the data and state for WebGL
     */
    i(this, "texture");
    /**
     * The width of the texture.
     */
    i(this, "width");
    /**
     * The height of the texture.
     */
    i(this, "height");
    /**
     * The binding point for the texture.
     * @default gl.TEXTURE_2D
     */
    i(this, "target");
    /**
     * The texture type. Typically one of gl.UNSIGNED_BYTE, gl.FLOAT, ext.HALF_FLOAT_OES
     * @default gl.UNSIGNED_BYTE
     */
    i(this, "type");
    /**
     * The texture format.
     * @default gl.RGBA
     */
    i(this, "format");
    /**
     * the texture internal format.
     * @default gl.RGBA
     */
    i(this, "internalFormat");
    /**
     * The filter to use when rendering smaller.
     */
    i(this, "minFilter");
    /**
     * The filter to use when rendering larger.
     */
    i(this, "magFilter");
    /**
     * Wrapping. Normally one of gl.CLAMP_TO_EDGE, gl.REPEAT, gl.MIRRORED REPEAT
     * @default gl.CLAMP_TO_EDGE
     */
    i(this, "wrapS");
    /**
     * Wrapping. Normally one of gl.CLAMP_TO_EDGE, gl.REPEAT, gl.MIRRORED REPEAT
     * @default gl.CLAMP_TO_EDGE
     */
    i(this, "wrapT");
    /**
     * Whether to generate mip maps for this texture. This requires that the texture be power of 2 in size
     * @default true
     */
    i(this, "generateMipmaps");
    /**
     * Whether the texture is interpolated as having premultiplied alpha.
     * @default false
     */
    i(this, "premultiplyAlpha");
    /**
     * Whether to flip the Y direction of the texture
     */
    i(this, "flipY");
    /**
     * The unpack alignment for pixel stores.
     */
    i(this, "unpackAlignment");
    /**
     * The anistropic filtering level for the texture.
     * @default 0
     */
    i(this, "anisotropy");
    /**
     * A GLint specifying the level of detail. Level 0 is the base image level and level n is the nth mipmap reduction level. Only relevant if we have mipmaps.
     * @default 0
     */
    i(this, "level");
    /**
     * The image store
     */
    i(this, "store");
    /**
     * A local reference to the renderer state
     */
    i(this, "glState");
    /**
     * Texture state, contains the basic texture properties.
     */
    i(this, "state");
    /**
     * Whether the texture needs an update in memory
     */
    i(this, "needsUpdate");
    this.gl = t, this.id = Ft++, e && (this.image = e), s && (this.data = s), this.target = r, this.type = a, this.format = n, this.internalFormat = u, this.minFilter = c, this.magFilter = f, this.wrapS = o, this.wrapT = h, this.generateMipmaps = l, this.premultiplyAlpha = g, this.unpackAlignment = x, this.flipY = m, this.anisotropy = Math.min(
      T,
      this.gl.renderer.parameters.maxAnisotropy
    ), this.level = _, E && (this.width = E), w && (this.height = w), this.texture = this.gl.createTexture(), this.store = {
      image: void 0
    }, this.state = {
      minFilter: this.gl.NEAREST_MIPMAP_LINEAR,
      magFilter: this.gl.LINEAR,
      wrapS: this.gl.REPEAT,
      wrapT: this.gl.REPEAT,
      anisotropy: 0
    }, this.needsUpdate = !0;
  }
  /**
   * Bind the texture. Skips over if it's determined that the texture is already bound.
   */
  bind() {
    this.gl.renderer.state.textureUnits[this.gl.renderer.state.activeTextureUnit] !== this.id && (this.gl.bindTexture(this.target, this.texture), this.gl.renderer.state.textureUnits[this.gl.renderer.state.activeTextureUnit] = this.id);
  }
  /**
   * Update the texture in graphics memory to the internal image and perform various state updates on an as-needs basis.
   * @param textureUnit The texture unit to update against.
   * @returns
   */
  update(t = 0) {
    const e = !(this.image === this.store.image && !this.needsUpdate);
    if ((e || this.gl.renderer.state.textureUnits[t] !== this.id) && (this.gl.renderer.activeTexture = t, this.bind()), !!e) {
      if (this.needsUpdate = !1, this.flipY !== this.gl.renderer.state.flipY && (this.gl.pixelStorei(this.gl.UNPACK_FLIP_Y_WEBGL, this.flipY), this.gl.renderer.state.flipY = this.flipY), this.premultiplyAlpha !== this.gl.renderer.state.premultiplyAlpha && (this.gl.pixelStorei(
        this.gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL,
        this.premultiplyAlpha
      ), this.gl.renderer.state.premultiplyAlpha = this.premultiplyAlpha), this.unpackAlignment !== this.gl.renderer.state.unpackAlignment && (this.gl.pixelStorei(this.gl.UNPACK_ALIGNMENT, this.unpackAlignment), this.gl.renderer.state.unpackAlignment = this.unpackAlignment), this.minFilter !== this.state.minFilter && (this.gl.texParameteri(
        this.target,
        this.gl.TEXTURE_MIN_FILTER,
        this.minFilter
      ), this.state.minFilter = this.minFilter), this.magFilter !== this.state.magFilter && (this.gl.texParameteri(
        this.target,
        this.gl.TEXTURE_MAG_FILTER,
        this.magFilter
      ), this.state.magFilter = this.magFilter), this.wrapS !== this.state.wrapS && (this.gl.texParameteri(this.target, this.gl.TEXTURE_WRAP_S, this.wrapS), this.state.wrapS = this.wrapS), this.wrapT !== this.state.wrapT && (this.gl.texParameteri(this.target, this.gl.TEXTURE_WRAP_T, this.wrapT), this.state.wrapT = this.wrapT), this.anisotropy && this.anisotropy !== this.state.anisotropy && (this.gl.texParameterf(
        this.target,
        this.gl.renderer.getExtension("EXT_texture_filter_anisotropic").TEXTURE_MAX_ANISOTROPY_EXT,
        this.anisotropy
      ), this.state.anisotropy = this.anisotropy), this.image || this.data) {
        if (this.image && "width" in this.image && (this.width = this.image.width, this.height = this.image.height), this.target === this.gl.TEXTURE_CUBE_MAP && Array.isArray(this.image))
          for (let s = 0; s < 6; s++)
            this.gl.texImage2D(
              this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + s,
              this.level,
              this.internalFormat,
              this.format,
              this.type,
              this.image[s]
            );
        else
          ArrayBuffer.isView(this.data) ? this.gl.texImage2D(
            this.target,
            this.level,
            this.internalFormat,
            this.width,
            this.height,
            0,
            this.format,
            this.type,
            this.data
          ) : Array.isArray(this.image) || this.gl.texImage2D(
            this.target,
            this.level,
            this.internalFormat,
            this.width,
            this.height,
            0,
            this.format,
            this.type,
            this.image
          );
        this.generateMipmaps && (!this.gl.renderer.isWebgl2 && this.image && !Array.isArray(this.image) && (!ft(this.image.width) || !ft(this.image.height)) ? (this.generateMipmaps = !1, this.wrapS = this.wrapT = this.gl.CLAMP_TO_EDGE, this.minFilter = this.gl.LINEAR) : this.gl.generateMipmap(this.target));
      } else if (this.target === this.gl.TEXTURE_CUBE_MAP)
        for (let s = 0; s < 6; s++)
          this.gl.texImage2D(
            this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + s,
            0,
            this.gl.RGBA,
            1,
            1,
            0,
            this.gl.RGBA,
            this.gl.UNSIGNED_BYTE,
            ct
          );
      else
        this.width ? this.gl.texImage2D(
          this.target,
          this.level,
          this.internalFormat,
          this.width,
          this.height,
          0,
          this.format,
          this.type,
          null
        ) : this.gl.texImage2D(
          this.target,
          0,
          this.gl.RGBA,
          1,
          1,
          0,
          this.gl.RGBA,
          this.gl.UNSIGNED_BYTE,
          ct
        );
      this.store.image = this.image;
    }
  }
}
class N {
  /**
   * Create a unform object
   * @param __namedParameters
   * @param name - The name of the uniform.
   * @param value - The value for the uniform.
   * @param kind - The type of uniform.
   */
  constructor({
    name: t = "uniform",
    value: e = [1, 1],
    kind: s = "float_vec2"
  } = {}) {
    /**
     * The uniform name. Currently unused, but for future use in auto-parsing name
     */
    i(this, "name");
    /**
     * The uniform value.
     */
    i(this, "value");
    /**
     * The uniform kind. Currently unused but useful in future for testing against supplied bind type.
     */
    i(this, "kind");
    this.name = t, this.value = e, this.kind = s;
  }
  /**
   * Set the uniform in the stated program.
   * @param gl - The WTCGL rendering context object.
   * @param type - A GLEnum representing the passed uniform type.
   * @param location - The uniform location (just an address to a uniform in program space)
   * @param value - The value of the uniform
   */
  setUniform(t, e, s, r = this.value) {
    const a = t.renderer.state.uniformLocations.get(s);
    if (r instanceof Array) {
      if (a === void 0 || a instanceof Array && a.length !== r.length)
        t.renderer.state.uniformLocations.set(s, r.slice(0));
      else if (a instanceof Array) {
        if (St(a, r))
          return;
        Pt(a, r), t.renderer.state.uniformLocations.set(s, a);
      }
    } else {
      if (a === r)
        return;
      t.renderer.state.uniformLocations.set(s, r);
    }
    const n = r;
    switch (e) {
      case 5126: {
        if (n instanceof Array)
          return t.uniform1fv(s, n);
        typeof n == "number" && t.uniform1f(s, n);
        return;
      }
      case 35664:
        return t.uniform2fv(s, n);
      case 35665:
        return t.uniform3fv(s, n);
      case 35666:
        return t.uniform4fv(s, n);
      case 35670:
      case 5124:
      case 35678:
      case 35680:
        return n != null && n.length ? t.uniform1iv(s, n) : t.uniform1i(s, n);
      case 35671:
      case 35667:
        return t.uniform2iv(s, n);
      case 35672:
      case 35668:
        return t.uniform3iv(s, n);
      case 35673:
      case 35669:
        return t.uniform4iv(s, n);
      case 35674:
        return t.uniformMatrix2fv(s, !1, n);
      case 35675:
        return t.uniformMatrix3fv(s, !1, n);
      case 35676:
        return n === null ? void 0 : t.uniformMatrix4fv(s, !1, n);
    }
  }
  /**
   * Binds the uniform to the program.
   * @param program - The program to which to bind the uniform.
   * @param location - A flag representing the uniform's location in memory.
   * @param activeUniform - Representes an extention of the standard Web GL active info for uniform.
   */
  bind(t, e, s) {
    if (this.value === void 0) {
      console.warn(`${this.name} uniform is missing a value`);
      return;
    }
    if (this.kind === "texture" && this.value instanceof V) {
      const r = ++t.textureUnit;
      return this.value.update(r), this.setUniform(
        t.gl,
        s.type,
        e,
        r
      );
    }
    if (this.kind === "texture_array" && this.value instanceof Array && this.value[0] instanceof V) {
      const r = [];
      return this.value.forEach((a) => {
        const n = ++t.textureUnit;
        a instanceof V && a.update(n), r.push(n);
      }), this.setUniform(
        t.gl,
        s.type,
        e,
        r
      );
    }
    this.setUniform(t.gl, s.type, e);
  }
}
function St(d, t) {
  if (d.length !== t.length)
    return !1;
  for (let e = 0, s = d.length; e < s; e++)
    if (d[e] !== t[e])
      return !1;
  return !0;
}
function Pt(d, t) {
  for (let e = 0, s = d.length; e < s; e++)
    d[e] = t[e];
}
class ht extends wt {
  /**
   * Create a mesh
   * @param {WTCGLRenderingContext} gl - The WTCGL Rendering context
   * @param {Object} __namedParameters - The parameters for the attribute
   * @param {Geometry} geometry - The geometry for the mesh to render
   * @param {Program} program - The program - shaders and uniforms - used to render the geometry
   * @param {GLenum} mode - The mode to render using
   * @param {boolean} frustumCulled - Whether to apply culling to this object
   * @param {number} renderOrder - The explicit render order of the object. If this is zero, then it will be instead calculated at render time.
   */
  constructor(e, {
    geometry: s,
    program: r,
    mode: a = e.TRIANGLES,
    frustumCulled: n = !0,
    renderOrder: u = 0
  }) {
    super(e, { frustumCulled: n, renderOrder: u });
    /**
     * The geometry to render.
     */
    i(this, "geometry");
    /**
     * The mode to use to draw this mesh. Can be one of:
     * - gl.POINTS: Draws a single dot for each vertex
     * - gl.LINE_STRIP: Draws a straight line between the vertices
     * - gl.LINE_LOOP: As above, but loops back.
     * - gl.LINES: Draws many lines between each vertex pair
     * - gl.TRIANGLE_STRIP: Draws a series of triangles between each vertice trio
     * - gl.TRIANGLE_FAN: Draws a series of triangles between each vertice trio, treating the first vertex as the origin of each triangle
     * - gl.TRIANGLES: Draws a triangle for a group of three vertices
     */
    i(this, "mode");
    /**
     * The world matrix projected by the camera's view matrix
     */
    i(this, "modelViewMatrix");
    /**
     * The model-view normal matrix
     */
    i(this, "normalMatrix");
    /**
     * Any callbacks to run before render
     */
    i(this, "beforeRenderCallbacks");
    /**
     * Any callbacks to run after render
     */
    i(this, "afterRenderCallbacks");
    e.canvas || console.error("gl not passed as first argument to Mesh"), this.geometry = s, this.program = r, this.mode = a, this.modelViewMatrix = new O(), this.normalMatrix = new dt(), this.beforeRenderCallbacks = [], this.afterRenderCallbacks = [];
  }
  /**
   * Add a before render callback.
   * @param {function} f - The function to call before render. Expected shape ({ mesh: this, camera })=>void.
   **/
  addBeforeRender(e) {
    return this.beforeRenderCallbacks.push(e), this;
  }
  /**
   * Remove a before render callback.
   * @param {function} f - The function to call before render. Expected shape ({ mesh: this, camera })=>void.
   **/
  removeBeforeRender(e) {
    this.beforeRenderCallbacks.forEach((s, r) => {
      s == e && this.beforeRenderCallbacks.splice(r, 1);
    });
  }
  /**
   * Remove all before render callbacks
   */
  removeAllBeforeRender() {
    this.beforeRenderCallbacks = [];
  }
  /**
   * Add an after render callback.
   * @param {function} f - The function to call before render. Expected shape ({ mesh: this, camera })=>void.
   **/
  addAfterRender(e) {
    return this.afterRenderCallbacks.push(e), this;
  }
  /**
   * Remove an after render callback.
   * @param {function} f - The function to call before render. Expected shape ({ mesh: this, camera })=>void.
   **/
  removeAfterRender(e) {
    this.afterRenderCallbacks.forEach((s, r) => {
      s == e && this.afterRenderCallbacks.splice(r, 1);
    });
  }
  /**
   * Remove all afyer render callbacks
   */
  removeAllAfterRender() {
    this.afterRenderCallbacks = [];
  }
  /**
   * Drw the mesh. If a camera is supplied to the draw call, its various matrices will be added to the program uniforms
   * @param {Camera} camera - The camera to use to supply transformation matrices
   */
  draw({ camera: e }) {
    this.beforeRenderCallbacks.forEach((r) => r && r({ mesh: this, camera: e })), e ? (this.program.uniforms.modelMatrix || Object.assign(this.program.uniforms, {
      u_modelMatrix: new N({
        name: "modelMatrix",
        value: void 0,
        kind: "mat4"
      }),
      u_viewMatrix: new N({
        name: "viewMatrix",
        value: void 0,
        kind: "mat4"
      }),
      u_modelViewMatrix: new N({
        name: "modelViewMatrix",
        value: void 0,
        kind: "mat4"
      }),
      u_normalMatrix: new N({
        name: "normalMatrix",
        value: void 0,
        kind: "mat3"
      }),
      u_projectionMatrix: new N({
        name: "projectionMatrix",
        value: void 0,
        kind: "mat4"
      }),
      u_cameraPosition: new N({
        name: "cameraPosition",
        value: void 0,
        kind: "float_vec3"
      }),
      u_objectPosition: new N({
        name: "objectPosition",
        value: void 0,
        kind: "float_vec3"
      })
    }), this.program.uniforms.u_projectionMatrix.value = e.projectionMatrix.array, this.program.uniforms.u_cameraPosition.value = e.worldPosition.array, this.program.uniforms.u_objectPosition.value = this.position.array, this.program.uniforms.u_viewMatrix.value = e.viewMatrix.array, this.modelViewMatrix = e.viewMatrix.multiplyNew(this.worldMatrix), this.normalMatrix = dt.fromMat4(this.modelViewMatrix), this.program.uniforms.u_modelMatrix.value = this.worldMatrix.array, this.program.uniforms.u_modelViewMatrix.value = this.modelViewMatrix.array, this.program.uniforms.u_normalMatrix.value = this.normalMatrix.array) : (this.program.uniforms.modelMatrix || Object.assign(this.program.uniforms, {
      u_objectPosition: new N({
        name: "objectPosition",
        value: void 0,
        kind: "float_vec3"
      })
    }), this.program.uniforms.u_objectPosition.value = this.position.array);
    const s = !!(this.program.cullFace && this.worldMatrix.determinant < 0);
    this.program.use({ flipFaces: s }), this.geometry.draw({ mode: this.mode, program: this.program }), this.afterRenderCallbacks.forEach((r) => r && r({ mesh: this, camera: e }));
  }
}
let Ot = 1;
class xt {
  /**
   * Create a Program
   * @param gl - The WTCGL Rendering context
   * @param __namedParameters - The parameters for the Program
   * @param vertex - The vertext shader
   * @param fragment - The fragment shader
   * @param uniforms - An object of uniforms for use in the program
   * @param transparent - Whether to render the program with transparency
   * @param cullFace - What method to use for determining face culling
   * @param frontFace - What method to use for determining the front of a face
   * @param depthTest - Whether to test the depth of a fragment against the depth buffer
   * @param depthWrite - Whether to write the depth information
   * @param depthFunc - The function to use when depth testing
   */
  constructor(t, {
    vertex: e,
    fragment: s,
    uniforms: r = {},
    transparent: a = !1,
    cullFace: n = t.BACK,
    frontFace: u = t.CCW,
    depthTest: o = !0,
    depthWrite: h = !0,
    depthFunc: l = t.LESS,
    transformFeedbackVaryings: c
  }) {
    /**
     * The ID of the program. Simple auto-incremening. Used for identifying the program for setup.
     */
    i(this, "id");
    /**
     * The WTCGL rendering context object
     */
    i(this, "gl");
    /**
     * The array uf uniforms for this program
     */
    i(this, "uniforms");
    /**
     * Whether to render transparency.
     * @default false
     */
    i(this, "transparent");
    /**
     * Whether to depth test objects in this program
     * @default true
     */
    i(this, "depthTest");
    /**
     * Whether to write depth information
     * @default true
     */
    i(this, "depthWrite");
    /**
     * Face culling used.
     * @default gl.BACK
     */
    i(this, "cullFace");
    /**
     * How to determine if a face is front-facing, whether it's points are drawn clockwise or counter-clockwise. Default is counter-clockwise.
     * @default gl.CCW
     */
    i(this, "frontFace");
    /**
     * The depth function to use when determinging the current pixel against the depth buffer
     * @default gl.LESS
     */
    i(this, "depthFunc");
    /**
     * The blend function to use
     */
    i(this, "blendFunc");
    /**
     * The blend equation to use
     */
    i(this, "blendEquation");
    /**
     * The webgl program store
     */
    i(this, "program");
    /**
     * A map of uniform locations in use within the program shaders
     */
    i(this, "uniformLocations");
    /**
     * A map of attribute locations in use within the program shaders
     */
    i(this, "attributeLocations");
    /**
     * A join of the found attributes. Used for addressing vertex array objects on the geometry.
     */
    i(this, "attributeOrder");
    /**
     * The texture unit. Used for addressing texture units in-program.
     */
    i(this, "textureUnit", -1);
    var _, E, w, b;
    t.canvas || console.error("gl not passed as first argument to Program"), this.gl = t, this.uniforms = r, this.id = Ot++, e || console.warn("vertex shader not supplied"), s || console.warn("fragment shader not supplied"), this.transparent = a, this.cullFace = n, this.frontFace = u, this.depthTest = o, this.depthWrite = h, this.depthFunc = l, this.transparent && !((_ = this.blendFunc) != null && _.src) && ((w = (E = this.gl) == null ? void 0 : E.renderer) != null && w.premultipliedAlpha ? this.setBlendFunc(this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA) : this.setBlendFunc(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA));
    const f = t.createShader(t.VERTEX_SHADER);
    f && (t.shaderSource(f, e), t.compileShader(f), t.getShaderInfoLog(f) !== "" && console.warn(
      `${t.getShaderInfoLog(
        f
      )}
Vertex Shader
${pt(e)}`
    ));
    const g = t.createShader(t.FRAGMENT_SHADER);
    if (g && (t.shaderSource(g, s), t.compileShader(g), t.getShaderInfoLog(g) !== "" && console.warn(
      `${t.getShaderInfoLog(
        g
      )}
Fragment Shader
${pt(s)}`
    )), this.program = t.createProgram(), f && t.attachShader(this.program, f), g && t.attachShader(this.program, g), c && ((b = t.transformFeedbackVaryings) == null || b.call(
      t,
      this.program,
      c,
      t.SEPARATE_ATTRIBS
    )), t.linkProgram(this.program), !t.getProgramParameter(this.program, t.LINK_STATUS))
      return console.warn(t.getProgramInfoLog(this.program)), this;
    t.deleteShader(f), t.deleteShader(g), this.uniformLocations = /* @__PURE__ */ new Map();
    const x = t.getProgramParameter(this.program, t.ACTIVE_UNIFORMS);
    for (let I = 0; I < x; I++) {
      const v = t.getActiveUniform(
        this.program,
        I
      );
      this.uniformLocations.set(
        v,
        t.getUniformLocation(this.program, v.name)
      );
      const P = v.name.match(/(\w+)/g);
      P != null && P.length && (v.uniformName = P[0], P.length === 3 ? (v.isStructArray = !0, v.structIndex = Number(P[1]), v.structProperty = P[2]) : P.length === 2 && isNaN(Number(P[1])) && (v.isStruct = !0, v.structProperty = P[1]));
    }
    this.attributeLocations = /* @__PURE__ */ new Map();
    const m = [], T = t.getProgramParameter(
      this.program,
      t.ACTIVE_ATTRIBUTES
    );
    for (let I = 0; I < T; I++) {
      const v = t.getActiveAttrib(this.program, I), P = t.getAttribLocation(this.program, v.name);
      m[P] = v.name, this.attributeLocations.set(v, P);
    }
    this.attributeOrder = m.join("");
  }
  /**
   * Set the blend function based on source and destination parameters
   * @param src - the source blend function
   * @param dst - The destination blend function
   * @param srcAlpha - the source blend function for alpha blending
   * @param dstAlpha - the destination blend function for alpha blending
   */
  setBlendFunc(t, e, s, r) {
    this.blendFunc.src = t, this.blendFunc.dst = e, this.blendFunc.srcAlpha = s, this.blendFunc.dstAlpha = r, t && (this.transparent = !0);
  }
  /**
   * set the blend equation
   * @param modeRGB - The mode to blend when using RGB
   * @param modeAlpha - The mode to blend when using RGBA
   */
  setBlendEquation(t, e) {
    this.blendEquation.modeRGB = t, this.blendEquation.modeAlpha = e;
  }
  /**
   * Apply the program state object to the renderer
   */
  applyState() {
    var t, e, s, r, a, n, u, o, h, l;
    this.depthTest ? (t = this.gl.renderer) == null || t.enable(this.gl.DEPTH_TEST) : (e = this.gl.renderer) == null || e.disable(this.gl.DEPTH_TEST), this.cullFace ? (s = this.gl.renderer) == null || s.enable(this.gl.CULL_FACE) : (r = this.gl.renderer) == null || r.disable(this.gl.CULL_FACE), (a = this.blendFunc) != null && a.src ? (n = this.gl.renderer) == null || n.enable(this.gl.BLEND) : (u = this.gl.renderer) == null || u.disable(this.gl.BLEND), this.cullFace && (this.gl.renderer.cullFace = this.cullFace), this.gl.renderer.frontFace = this.frontFace, this.gl.renderer.depthMask = this.depthWrite, this.gl.renderer.depthFunc = this.depthFunc, (o = this.blendFunc) != null && o.src && this.gl.renderer.setBlendFunc(
      this.blendFunc.src,
      this.blendFunc.dst,
      this.blendFunc.srcAlpha,
      this.blendFunc.dstAlpha
    ), this.gl.renderer.setBlendEquation(
      (h = this.blendEquation) == null ? void 0 : h.modeRGB,
      (l = this.blendEquation) == null ? void 0 : l.modeAlpha
    );
  }
  /**
   * Set up the program for use
   * @param flipFaces - Flip the faces, for when a mesh is scaled in teh negative
   */
  use({ flipFaces: t = !1 } = {}) {
    this.textureUnit = -1, this.gl.renderer.currentProgram === this.id || (this.gl.useProgram(this.program), this.gl.renderer.currentProgram = this.id), this.uniformLocations.forEach((s, r) => {
      const a = r.uniformName;
      if (!a)
        return;
      const n = this.uniforms[a];
      if (!n)
        return Nt(`Active uniform ${a} has not been supplied`);
      n.bind(this, s, r);
    }), this.applyState(), t && (this.gl.renderer.frontFace = this.frontFace === this.gl.CCW ? this.gl.CW : this.gl.CCW);
  }
  /**
   * Delete the program
   */
  remove() {
    this.gl.deleteProgram(this.program);
  }
}
function pt(d) {
  const t = d.split(`
`);
  for (let e = 0; e < t.length; e++)
    t[e] = e + 1 + ": " + t[e];
  return t.join(`
`);
}
let rt = 0;
function Nt(d) {
  rt > 100 || (console.warn(d), rt++, rt > 100 && console.warn("More than 100 program warnings - stopping logs."));
}
class Tt extends At {
  /**
   * Create a camera object
   * @param {Object} __namedParameters - The parameters to be used for the camera
   * @param {number} near - The near point of the perspective matrix
   * @param {number} far - The far point of the perspective matrix
   * @param {number} fov - The fov of the camera, in degrees
   * @param {number} aspect - The camera aspect ratio
   * @param {number} left - The left point of the orthographic camera
   * @param {number} right - The right point of the orthographic camera
   * @param {number} top - The top point of the orthographic camera
   * @param {number} bottom - The bottom point of the orthographic camera
   * @param {number} zoom - The zoom level of the orthographic camera
   */
  constructor({
    near: e = 0.1,
    far: s = 100,
    fov: r = 45,
    aspect: a = 1,
    left: n,
    right: u,
    top: o,
    bottom: h,
    zoom: l = 1
  }) {
    super();
    /**
     * The near point of the perspective matrix
     * @default .1
     */
    i(this, "near");
    /**
     * The far point of the perspective matrix
     * @default 100
     */
    i(this, "far");
    /**
     * The field of view of the perspective matrix, in degrees
     * @default 45
     */
    i(this, "fov");
    /**
     * The aspect ratio of the perspective matric - normally defined as width / height
     * @default 1
     */
    i(this, "aspect");
    /**
     * The left plane of the orthagraphic view
     */
    i(this, "left");
    /**
     * The right plane of the orthagraphic view
     */
    i(this, "right");
    /**
     * The top plane of the orthagraphic view
     */
    i(this, "top");
    /**
     * The bottom plane of the orthagraphic view
     */
    i(this, "bottom");
    /**
     * The zoom level of the orthagraphic view
     * @default 1
     */
    i(this, "zoom");
    /**
     * The camera projection matrix gives a vector space projection to a subspace.
     */
    i(this, "projectionMatrix");
    /**
     * The camera view matrix transforms vertices from world-space to view-space.
     */
    i(this, "viewMatrix");
    /**
     * The combined projection and view matrix.
     */
    i(this, "projectionViewMatrix");
    /**
     * The position in world space
     */
    i(this, "worldPosition");
    /**
     * The camera type - perspective or orthographic. If left / right are provided this will default to orthographic, otherwise it will default to perspective
     */
    i(this, "type");
    i(this, "frustum");
    this.near = e, this.far = s, this.fov = r, this.aspect = a, this.left = n, this.right = u, this.top = o, this.bottom = h, this.zoom = l, this.projectionMatrix = new O(), this.viewMatrix = new O(), this.projectionViewMatrix = new O(), this.worldPosition = new p(), this.type = n || u ? "orthographic" : "perspective", this.type === "orthographic" ? this.orthographic() : this.perspective();
  }
  /**
   * Calculate the parameters necessary for a perspective camera
   * @param {Object} __namedParameters - The parameters to be used for the camera
   * @param {number} near - The near point of the perspective matrix
   * @param {number} far - The far point of the perspective matrix
   * @param {number} fov - The fov of the camera, in degrees
   * @param {number} aspect - The camera aspect ratio
   */
  perspective({
    near: e = this.near,
    far: s = this.far,
    fov: r = this.fov,
    aspect: a = this.aspect
  } = {}) {
    return Object.assign(this, { near: e, far: s, fov: r, aspect: a }), this.projectionMatrix = O.perspective(
      r * Math.PI / 180,
      a,
      e,
      s
    ), this.type = "perspective", this;
  }
  /**
   * Calculate the parameters necessary for an orthographic camera
   * @param {Object} __namedParameters - The parameters to be used for the camera
   * @param {number} near - The near point of the perspective matrix
   * @param {number} far - The far point of the perspective matrix
   * @param {number} left - The left point of the orthographic camera
   * @param {number} right - The right point of the orthographic camera
   * @param {number} top - The top point of the orthographic camera
   * @param {number} bottom - The bottom point of the orthographic camera
   * @param {number} zoom - The zoom level of the orthographic camera
   */
  orthographic({
    near: e = this.near,
    far: s = this.far,
    left: r = this.left,
    right: a = this.right,
    bottom: n = this.bottom,
    top: u = this.top,
    zoom: o = this.zoom
  } = {}) {
    return Object.assign(this, { near: e, far: s, left: r, right: a, bottom: n, top: u, zoom: o }), r /= o, a /= o, n /= o, u /= o, this.projectionMatrix = O.ortho(r, a, n, u, e, s), this.type = "orthographic", this;
  }
  /**
   * Update the world view matrices
   * @chainable
   * @returns The camera operated on to make function chainable
   */
  updateMatrixWorld() {
    return super.updateMatrixWorld(), this.viewMatrix = this.worldMatrix.invertNew(), this.worldPosition = this.worldMatrix.translation, this.projectionViewMatrix = this.projectionMatrix.multiplyNew(
      this.viewMatrix
    ), this;
  }
  /**
   * Look at a position
   * @param {Vec3} target - The position to look at
   * @chainable
   * @returns The camera operated on to make function chainable
   */
  lookAt(e) {
    return super.lookAt(e, !0), this;
  }
  /**
   * Update the frustum parameters based on the prejection view matrix
   */
  updateFrustum() {
    this.frustum || (this.frustum = {
      xNeg: { pos: new p(), constant: 0 },
      xPos: { pos: new p(), constant: 0 },
      yNeg: { pos: new p(), constant: 0 },
      yPos: { pos: new p(), constant: 0 },
      zNeg: { pos: new p(), constant: 0 },
      zPos: { pos: new p(), constant: 0 }
    });
    const e = this.projectionViewMatrix;
    this.frustum.xNeg.pos = new p(
      e.a14 - e.a11,
      e.a24 - e.a21,
      e.a34 - e.a31
    ), this.frustum.xNeg.constant = e.a44 - e.a41, this.frustum.xPos.pos = new p(
      e.a14 + e.a11,
      e.a24 + e.a21,
      e.a34 + e.a31
    ), this.frustum.xPos.constant = e.a44 + e.a41, this.frustum.yPos.pos = new p(
      e.a14 + e.a12,
      e.a24 + e.a22,
      e.a34 + e.a32
    ), this.frustum.yPos.constant = e.a44 + e.a42, this.frustum.yNeg.pos = new p(
      e.a14 - e.a12,
      e.a24 - e.a22,
      e.a34 - e.a32
    ), this.frustum.yNeg.constant = e.a44 - e.a42, this.frustum.zPos.pos = new p(
      e.a14 - e.a13,
      e.a24 - e.a23,
      e.a34 - e.a33
    ), this.frustum.zPos.constant = e.a44 - e.a43, this.frustum.zNeg.pos = new p(
      e.a14 + e.a13,
      e.a24 + e.a23,
      e.a34 + e.a33
    ), this.frustum.zNeg.constant = e.a44 + e.a43;
    for (const s in this.frustum) {
      const r = 1 / this.frustum[s].pos.length;
      this.frustum[s].pos.scale(r), this.frustum[s].constant *= r;
    }
  }
  /**
   * Determines whether the camera frustum intersects the supplied drawable object. Used mainly for frustum culling.
   * @param {Drawable} node - The node to test intersection against
   * @returns Boolean indicating intersection
   */
  frustumIntersects(e) {
    if (e instanceof ht) {
      if (!e.geometry.attributes.position || ((!e.geometry.bounds || e.geometry.bounds.radius === 1 / 0) && e.geometry.computeBoundingSphere(), !e.geometry.bounds))
        return !0;
      const s = e.geometry.bounds.center.clone();
      s.transformByMat4(e.worldMatrix);
      const r = e.geometry.bounds.radius * this.maxAxisScale(e.worldMatrix);
      return this.frustumIntersectsSphere(s, r);
    }
    return !1;
  }
  /**
   * Determines the largist axis scale of a matrix
   * @param {Mat4} m - The matrix to find the max axis of
   * @returns The max axis scale
   */
  maxAxisScale(e) {
    const s = e.a11 * e.a11 + e.a12 * e.a12 + e.a13 * e.a13, r = e.a21 * e.a21 + e.a22 * e.a22 + e.a23 * e.a23, a = e.a31 * e.a31 + e.a32 * e.a32 + e.a33 * e.a33;
    return Math.sqrt(Math.max(s, r, a));
  }
  /**
   * Determines whether the frustum intersects a sphere
   * @param {Vec3} center - The center of the sphere to test.
   * @param {number} radius - The radius of the sphere to test.
   * @returns Boolean indicating intersection
   */
  frustumIntersectsSphere(e, s) {
    for (const r in this.frustum) {
      const a = this.frustum[r];
      if (a.pos.clone().dot(e) + a.constant < -s)
        return !1;
    }
    return !0;
  }
}
const F = class F extends Tt {
  constructor({
    element: e = document.body,
    enabled: s = !0,
    target: r = new p(0, 0, 0),
    ease: a = 0.25,
    inertia: n = 0.5,
    enableRotate: u = !0,
    rotateSpeed: o = 0.5,
    autoRotate: h = !1,
    autoRotateSpeed: l = 1,
    enableZoom: c = !0,
    zoomSpeed: f = 1,
    zoomStyle: g = "dolly",
    enablePan: x = !0,
    panSpeed: m = 0.5,
    minPolarAngle: T = 0,
    maxPolarAngle: _ = Math.PI,
    minAzimuthAngle: E = -1 / 0,
    maxAzimuthAngle: w = 1 / 0,
    minDistance: b = 0,
    maxDistance: I = 1 / 0
  } = {}, v) {
    super(v);
    i(this, "element");
    i(this, "enabled");
    i(this, "target");
    i(this, "zoomStyle");
    i(this, "minDistance");
    i(this, "maxDistance");
    i(this, "enableRotate");
    i(this, "autoRotate");
    i(this, "enableZoom");
    i(this, "enablePan");
    i(this, "ease");
    i(this, "inertia");
    i(this, "rotateSpeed");
    i(this, "autoRotateSpeed");
    i(this, "zoomSpeed");
    i(this, "panSpeed");
    i(this, "minPolarAngle");
    i(this, "maxPolarAngle");
    i(this, "minAzimuthAngle");
    i(this, "maxAzimuthAngle");
    i(this, "sphericalDelta");
    i(this, "sphericalTarget");
    i(this, "spherical");
    i(this, "panDelta");
    i(this, "offset");
    i(this, "rotateStart");
    i(this, "panStart");
    i(this, "dollyStart");
    i(this, "state");
    i(this, "mouseButtons");
    this.element = e, this.enabled = s, this.target = r, this.zoomStyle = g, this.ease = a || 1, this.inertia = n || 0, this.enableRotate = u, this.rotateSpeed = o, this.autoRotate = h, this.autoRotateSpeed = l, this.enableZoom = c, this.zoomSpeed = f, this.enablePan = x, this.panSpeed = m, this.minPolarAngle = T, this.maxPolarAngle = _, this.minAzimuthAngle = E, this.maxAzimuthAngle = w, this.minDistance = b, this.maxDistance = I, this.sphericalDelta = new p(1, 0, 0), this.sphericalTarget = new p(1, 0, 0), this.spherical = new p(1, 0, 0), this.panDelta = new p(), this.setPosition(this.position.x, this.position.y, this.position.z), this.rotateStart = new M(), this.panStart = new M(), this.dollyStart = new M(), this.state = F.STATE_NONE, this.mouseButtons = { ORBIT: 0, ZOOM: 1, PAN: 2 }, this.onContextMenu = this.onContextMenu.bind(this), this.onMouseDown = this.onMouseDown.bind(this), this.onMouseWheel = this.onMouseWheel.bind(this), this.onTouchStart = this.onTouchStart.bind(this), this.onTouchEnd = this.onTouchEnd.bind(this), this.onTouchMove = this.onTouchMove.bind(this), this.onMouseMove = this.onMouseMove.bind(this), this.onMouseUp = this.onMouseUp.bind(this), this.addHandlers();
  }
  setPosition(e, s, r) {
    this.position.reset(e, s, r), this.offset = this.position.subtractNew(this.target), this.spherical.radius = this.sphericalTarget.radius = this.offset.length, this.spherical.theta = this.sphericalTarget.theta = Math.atan2(
      this.offset.x,
      this.offset.z
    ), this.spherical.phi = this.sphericalTarget.phi = Math.acos(
      Math.min(Math.max(this.offset.y / this.sphericalTarget.radius, -1), 1)
    );
  }
  update() {
    this.autoRotate && this.handleAutoRotate(), this.sphericalTarget.radius *= this.sphericalDelta.radius, this.sphericalTarget.theta += this.sphericalDelta.theta, this.sphericalTarget.phi += this.sphericalDelta.phi, this.sphericalTarget.theta = Math.max(
      this.minAzimuthAngle,
      Math.min(this.maxAzimuthAngle, this.sphericalTarget.theta)
    ), this.sphericalTarget.phi = Math.max(
      this.minPolarAngle,
      Math.min(this.maxPolarAngle, this.sphericalTarget.phi)
    ), this.sphericalTarget.radius = Math.max(
      this.minDistance,
      Math.min(this.maxDistance, this.sphericalTarget.radius)
    ), this.spherical.phi += (this.sphericalTarget.phi - this.spherical.phi) * this.ease, this.spherical.theta += (this.sphericalTarget.theta - this.spherical.theta) * this.ease, this.spherical.radius += (this.sphericalTarget.radius - this.spherical.radius) * this.ease, this.target.add(this.panDelta);
    const e = this.spherical.radius * Math.sin(Math.max(1e-6, this.spherical.phi));
    this.offset.x = e * Math.sin(this.spherical.theta), this.offset.y = this.spherical.radius * Math.cos(this.spherical.phi), this.offset.z = e * Math.cos(this.spherical.theta), this.position.resetToVector(this.target.addNew(this.offset)), this.lookAt(this.target), this.sphericalDelta.theta *= this.inertia, this.sphericalDelta.phi *= this.inertia, this.panDelta.scale(this.inertia), this.sphericalDelta.radius = 1;
  }
  forcePosition() {
    this.offset = this.position.subtractNew(this.target), this.spherical.radius = this.sphericalTarget.radius = this.offset.length, this.spherical.theta = this.sphericalTarget.theta = Math.atan2(
      this.offset.x,
      this.offset.z
    ), this.spherical.phi = this.sphericalTarget.phi = Math.acos(
      Math.min(Math.max(this.offset.y / this.sphericalTarget.radius, -1), 1)
    ), this.lookAt(this.target);
  }
  getZoomScale() {
    return Math.pow(0.95, this.zoomSpeed);
  }
  panLeft(e, s) {
    const r = new p(s[0], s[1], s[2]);
    r.scale(-e), this.panDelta.add(r);
  }
  panUp(e, s) {
    const r = new p(s[4], s[5], s[6]);
    r.scale(e), this.panDelta.add(r);
  }
  pan(e, s) {
    const r = this.element;
    let n = this.position.subtractNew(this.target).length;
    n *= Math.tan((this.fov || 45) / 2 * Math.PI / 180), this.panLeft(
      2 * e * n / r.clientHeight,
      this.matrix.array
    ), this.panUp(
      2 * s * n / r.clientHeight,
      this.matrix.array
    );
  }
  dolly(e) {
    this.zoomStyle === "dolly" ? this.sphericalDelta.radius /= e : (this.fov /= e, this.type === "orthographic" ? this.orthographic() : this.perspective());
  }
  handleAutoRotate() {
    const e = 2 * Math.PI / 60 / 60 * this.autoRotateSpeed;
    this.sphericalDelta.theta -= e;
  }
  handleMoveRotate(e, s) {
    const r = new M(e, s), a = r.subtractNew(this.rotateStart).scale(this.rotateSpeed), n = this.element;
    this.sphericalDelta.theta -= 2 * Math.PI * a.x / n.clientHeight, this.sphericalDelta.phi -= 2 * Math.PI * a.y / n.clientHeight, this.rotateStart.resetToVector(r);
  }
  handleMouseMoveDolly(e) {
    const s = new M(e.clientX, e.clientY), r = s.subtractNew(this.dollyStart);
    r.y > 0 ? this.dolly(this.getZoomScale()) : r.y < 0 && this.dolly(1 / this.getZoomScale()), this.dollyStart.resetToVector(s);
  }
  handleMovePan(e, s) {
    const r = new M(e, s), a = r.subtractNew(this.panStart).scale(this.panSpeed);
    this.pan(a.x, a.y), this.panStart.resetToVector(r);
  }
  handleTouchStartDollyPan(e) {
    if (this.enableZoom) {
      const s = new M(
        e.touches[0].pageX - e.touches[1].pageX,
        e.touches[0].pageY - e.touches[1].pageY
      ).length;
      this.dollyStart.reset(0, s);
    }
    this.enablePan && this.panStart.reset(
      0.5 * (e.touches[0].pageX + e.touches[1].pageX),
      0.5 * (e.touches[0].pageY + e.touches[1].pageY)
    );
  }
  handleTouchMoveDollyPan(e) {
    if (this.enableZoom) {
      const s = new M(
        e.touches[0].pageX - e.touches[1].pageX,
        e.touches[0].pageY - e.touches[1].pageY
      ), r = new M(0, s.length), a = new M(
        0,
        Math.pow(r.y / this.dollyStart.y, this.zoomSpeed)
      );
      this.dolly(a.y), this.dollyStart.resetToVector(r);
    }
    if (this.enablePan) {
      const s = 0.5 * (e.touches[0].pageX + e.touches[1].pageX), r = 0.5 * (e.touches[0].pageY + e.touches[1].pageY);
      this.handleMovePan(s, r);
    }
  }
  onMouseDown(e) {
    if (this.enabled) {
      switch (e.button) {
        case this.mouseButtons.ORBIT:
          if (this.enableRotate === !1)
            return;
          this.rotateStart.reset(e.clientX, e.clientY), this.state = F.STATE_ROTATE;
          break;
        case this.mouseButtons.ZOOM:
          if (this.enableZoom === !1)
            return;
          this.dollyStart.reset(e.clientX, e.clientY), this.state = F.STATE_DOLLY;
          break;
        case this.mouseButtons.PAN:
          if (this.enablePan === !1)
            return;
          this.panStart.reset(e.clientX, e.clientY), this.state = F.STATE_PAN;
          break;
      }
      this.state !== F.STATE_NONE && (window.addEventListener("mousemove", this.onMouseMove, !1), window.addEventListener("mouseup", this.onMouseUp, !1));
    }
  }
  onMouseMove(e) {
    if (this.enabled)
      switch (this.state) {
        case F.STATE_ROTATE:
          if (this.enableRotate === !1)
            return;
          this.handleMoveRotate(e.clientX, e.clientY);
          break;
        case F.STATE_DOLLY:
          if (this.enableZoom === !1)
            return;
          this.handleMouseMoveDolly(e);
          break;
        case F.STATE_PAN:
          if (this.enablePan === !1)
            return;
          this.handleMovePan(e.clientX, e.clientY);
          break;
      }
  }
  onMouseUp() {
    window.removeEventListener("mousemove", this.onMouseMove, !1), window.removeEventListener("mouseup", this.onMouseUp, !1), this.state = F.STATE_NONE;
  }
  onMouseWheel(e) {
    !this.enabled || !this.enableZoom || this.state !== F.STATE_NONE && this.state !== F.STATE_ROTATE || (e.stopPropagation(), e.preventDefault(), e.deltaY < 0 ? this.dolly(1 / this.getZoomScale()) : e.deltaY > 0 && this.dolly(this.getZoomScale()));
  }
  onTouchStart(e) {
    if (this.enabled)
      switch (e.preventDefault(), e.touches.length) {
        case 1:
          if (this.enableRotate === !1)
            return;
          this.rotateStart.reset(e.touches[0].pageX, e.touches[0].pageY), this.state = F.STATE_ROTATE;
          break;
        case 2:
          if (this.enableZoom === !1 && this.enablePan === !1)
            return;
          this.handleTouchStartDollyPan(e), this.state = F.STATE_DOLLY_PAN;
          break;
        default:
          this.state = F.STATE_NONE;
      }
  }
  onTouchMove(e) {
    if (this.enabled)
      switch (e.preventDefault(), e.stopPropagation(), e.touches.length) {
        case 1:
          if (this.enableRotate === !1)
            return;
          this.handleMoveRotate(e.touches[0].pageX, e.touches[0].pageY);
          break;
        case 2:
          if (this.enableZoom === !1 && this.enablePan === !1)
            return;
          this.handleTouchMoveDollyPan(e);
          break;
        default:
          this.state = F.STATE_NONE;
      }
  }
  onTouchEnd() {
    this.enabled && (this.state = F.STATE_NONE);
  }
  onContextMenu(e) {
    this.enablePan && this.enabled && e.preventDefault();
  }
  addHandlers() {
    this.element.addEventListener("contextmenu", this.onContextMenu, !1), this.element.addEventListener("mousedown", this.onMouseDown, !1), this.element.addEventListener("wheel", this.onMouseWheel, {
      passive: !1
    }), this.element.addEventListener("touchstart", this.onTouchStart, {
      passive: !1
    }), this.element.addEventListener("touchend", this.onTouchEnd, !1), this.element.addEventListener("touchmove", this.onTouchMove, {
      passive: !1
    });
  }
  removeHandlers() {
    this.element.removeEventListener("contextmenu", this.onContextMenu), this.element.removeEventListener("mousedown", this.onMouseDown), this.element.removeEventListener("wheel", this.onMouseWheel), this.element.removeEventListener("touchstart", this.onTouchStart), this.element.removeEventListener("touchend", this.onTouchEnd), this.element.removeEventListener("touchmove", this.onTouchMove), window.removeEventListener("mousemove", this.onMouseMove), window.removeEventListener("mouseup", this.onMouseUp);
  }
};
i(F, "STATE_NONE", 0), i(F, "STATE_ROTATE", 1), i(F, "STATE_DOLLY", 2), i(F, "STATE_PAN", 4), i(F, "STATE_DOLLY_PAN", 8);
let mt = F;
class Lt {
  /**
   * Create a render target object.
   * @param {WTCGLRenderingContext} gl - The WTCGL Rendering context
   * @param __namedParameters - The parameters to initialise the renderer.
   * @param width - The width of the render target.
   * @param height - The height of the render target.
   * @param target - The binding point for the frame buffers.
   * @param colour - The number of colour attachments to create.
   * @param depth - Whether to create a depth buffer
   * @param stencil - Whether to create a stencil buffer
   * @param wrapS - Wrapping
   * @param wrapT - Wrapping
   * @param minFilter - The filter to use when rendering smaller
   * @param magFilter - The filter to use when enlarging
   * @param type - The texture type. Typically one of gl.UNSIGNED_BYTE, gl.FLOAT, ext.HALF_FLOAT_OES
   * @param format - The texture format.
   * @param internalFormat - the texture internalFormat.
   * @param unpackAlignment - The unpack alignment for pixel stores.
   * @param premultiplyAlpha - Whether to use premultiplied alpha for stored textures.
   */
  constructor(t, {
    data: e,
    width: s = t.canvas.width,
    height: r = t.canvas.height,
    target: a = t.FRAMEBUFFER,
    colour: n = 1,
    depth: u = !0,
    wrapS: o = t.CLAMP_TO_EDGE,
    wrapT: h = t.CLAMP_TO_EDGE,
    minFilter: l = t.LINEAR,
    magFilter: c = l,
    type: f = t.UNSIGNED_BYTE,
    format: g = t.RGBA,
    internalFormat: x = g,
    unpackAlignment: m = 4,
    premultiplyAlpha: T = !1
  } = {}) {
    /**
     * The WTCGL rendering context.
     */
    i(this, "gl");
    /**
     * The WebGL frame buffer object to render to.
     */
    i(this, "buffer");
    /**
     * The texture array. If you supply only one colour, you can just output this as you normally would with gl_FragColor, otherwise you need to output one at a time with gl_FragData[x]
     */
    i(this, "textures");
    /**
     * The depth buffer.
     */
    i(this, "depthBuffer");
    /**
     * The stencil buffer.
     */
    i(this, "stencilBuffer");
    /**
     * The depth-stencil buffer.
     */
    i(this, "depthStencilBuffer");
    /**
     * The depth texture.
     */
    i(this, "depthTexture");
    /**
     * The width of the target.
     */
    i(this, "width");
    /**
     * The height of the target.
     */
    i(this, "height");
    /**
     * Whether to render a depth buffer.
     */
    i(this, "depth");
    /**
     * Whether to render a stencil buffer.
     */
    i(this, "stencil");
    /**
     * A GLEnum representing the binding point for the texture / buffer.
     * @default gl.FRAMEBUFFER
     */
    i(this, "target");
    var w;
    this.gl = t, this.width = s, this.height = r, this.depth = u, this.buffer = this.gl.createFramebuffer(), this.target = a, this.gl.bindFramebuffer(this.target, this.buffer);
    const _ = t.getExtension("OES_texture_half_float");
    (f === (_ == null ? void 0 : _.HALF_FLOAT_OES) || f === this.gl.HALF_FLOAT) && (w = t == null ? void 0 : t.renderer) != null && w.isWebgl2 && (x = this.gl.RGBA16F), this.textures = [];
    const E = [];
    for (let b = 0; b < n; b++)
      this.textures.push(
        new V(t, {
          data: e,
          width: s,
          height: r,
          wrapS: o,
          wrapT: h,
          minFilter: l,
          magFilter: c,
          type: f,
          format: g,
          internalFormat: x,
          unpackAlignment: m,
          premultiplyAlpha: T,
          flipY: !1,
          generateMipmaps: !1
        })
      ), this.textures[b].update(), this.gl.framebufferTexture2D(
        this.target,
        this.gl.COLOR_ATTACHMENT0 + b,
        this.gl.TEXTURE_2D,
        this.textures[b].texture,
        0
        /* level */
      ), E.push(this.gl.COLOR_ATTACHMENT0 + b);
    E.length > 1 && this.gl.renderer.drawBuffers(E), u && (this.gl.renderer.isWebgl2 || this.gl.renderer.getExtension("WEBGL_depth_texture")) && (this.depthTexture = new V(t, {
      width: s,
      height: r,
      minFilter: this.gl.NEAREST,
      magFilter: this.gl.NEAREST,
      format: this.gl.DEPTH_COMPONENT,
      internalFormat: t.renderer.isWebgl2 ? this.gl.DEPTH_COMPONENT16 : this.gl.DEPTH_COMPONENT,
      type: this.gl.UNSIGNED_INT
    }), this.depthTexture.update(), this.gl.framebufferTexture2D(
      this.target,
      this.gl.DEPTH_ATTACHMENT,
      this.gl.TEXTURE_2D,
      this.depthTexture.texture,
      0
      /* level */
    )), this.gl.bindFramebuffer(this.target, null);
  }
  /**
   * Returns the first texture, for the majority os use cases.
   */
  get texture() {
    return this.textures[0];
  }
}
const It = (d, t, e = d.STATIC_DRAW, s = d.ARRAY_BUFFER) => {
  const r = d.createBuffer();
  return d.bindBuffer(s, r), d.bufferData(s, t, e), r;
};
class Wt {
  constructor(t, { program: e, transformFeedbacks: s }) {
    i(this, "VAOs");
    i(this, "TFBs");
    i(this, "BufferRefs");
    this.VAOs = [t.createVertexArray(), t.createVertexArray()], this.TFBs = [t.createTransformFeedback(), t.createTransformFeedback()], this.BufferRefs = [];
    const r = Object.keys(s);
    this.VAOs.forEach((a, n) => {
      t.bindVertexArray(a);
      const u = [], o = {};
      for (let h = 0; h < r.length; h++) {
        const l = s[r[h]], {
          size: c = 1,
          type: f = t.FLOAT,
          normalize: g = !1,
          stride: x = 0,
          offset: m = 0,
          data: T,
          usage: _ = t.STATIC_DRAW,
          buffertype: E = t.ARRAY_BUFFER,
          buffer: w = null
        } = l, b = T && !w ? It(t, T, _, E) : w;
        o[r[h]] = { i: h, buffer: b }, t.bindAttribLocation(e, h, r[h]), t.enableVertexAttribArray(h), t.bindBuffer(t.ARRAY_BUFFER, b), t.vertexAttribPointer(h, c, f, g, x, m), u.push(b);
      }
      t.bindBuffer(t.ARRAY_BUFFER, null), t.bindTransformFeedback(t.TRANSFORM_FEEDBACK, this.TFBs[n]), u.forEach((h, l) => {
        t.bindBufferBase(t.TRANSFORM_FEEDBACK_BUFFER, l, h);
      }), t.bindVertexArray(null), this.BufferRefs.push(o);
    });
  }
}
let Bt = 1, gt = !1;
const Dt = function(d, t = 0) {
  return new p(d[t], d[t + 1], d[t + 2]);
};
class it {
  /**
   * Create a geometry object.
   * @param {WTCGLRenderingContext} gl - The WTCGL Rendering context
   * @param {WTCGLGeometryAttributeCollection} attributes - A collection of attributes for the geometry. Typically includes vertex positions in 2 or 3d, normals etc.
   */
  constructor(t, e = {}, s) {
    /**
     * The unique ID of the Geometry.
     */
    i(this, "id");
    /**
     * The WTCGL rendering context.
     */
    i(this, "gl");
    /**
     * The WTCGL attribute collection that describes this geometry.
     */
    i(this, "attributes");
    /**
     * An array of vertex array objects that represent the different attributes.
     */
    i(this, "VAOs");
    /**
     * Any supplied transform feedback objects
     */
    i(this, "transformFeedbacks");
    i(this, "transformFeedbackIndex", 0);
    /**
     * The range of supplied elements to draw.
     */
    i(this, "drawRange");
    /**
     * The number of instances to draw.
     */
    i(this, "instancedCount");
    /**
     * A boolean indicating whether the geometry is an instanced geometry or not.
     */
    i(this, "isInstanced");
    /**
     * An object defining the boundary of the geometry
     */
    i(this, "bounds");
    /**
     * An object defining all of the rendering state properties.
     */
    i(this, "glState");
    t.canvas || console.error("gl not passed as first argument to Geometry"), this.gl = t, this.attributes = e, this.id = Bt++, this.VAOs = {}, s && (this.transformFeedbacks = s), this.gl.renderer.bindVertexArray(null), this.drawRange = { start: 0, count: 0 }, this.instancedCount = 0;
    for (const r in e)
      this.addAttribute(r, e[r]);
  }
  /**
   * Add an attribute
   * @param {string} key - The key for the attribute
   * @param {WTCGLGeometryAttribute} attr - The Geometry attribute, basically the data to be injected
   */
  addAttribute(t, e) {
    if (this.attributes[t] = e, e.target = t === "index" ? this.gl.ELEMENT_ARRAY_BUFFER : this.gl.ARRAY_BUFFER, e.count = e.count || (e.stride ? e.data.byteLength / e.stride : e.data.length / e.size), e.needsUpdate = !1, e.buffer || (e.buffer = this.gl.createBuffer(), e.updateAttribute(this.gl)), e.divisor) {
      if (this.isInstanced = !0, this.instancedCount && this.instancedCount !== e.count * e.divisor) {
        console.warn(
          "geometry has multiple instanced buffers of different length"
        ), this.instancedCount = Math.min(
          this.instancedCount,
          e.count * e.divisor
        );
        return;
      }
      this.instancedCount = e.count * e.divisor;
    } else
      t === "index" ? this.drawRange.count = e.count : this.attributes.index || (this.drawRange.count = Math.max(this.drawRange.count, e.count));
  }
  /**
   * Sets up the draw range, used to determined which properties are drawn
   * @param {number} start - The start of the range
   * @param {number} count - The number of properties to draw
   */
  setDrawRange(t, e) {
    this.drawRange.start = t, this.drawRange.count = e;
  }
  /**
   * Sets up the number of instances to draw
   * @param {number} value - The number of geometry instances to draw
   */
  setInstancedCount(t) {
    this.instancedCount = t;
  }
  /**
   * Create a new vertex array object bind Attributes to it
   * @param {Program} program - The program to use to determine attribute locations
   */
  createVAO(t) {
    this.VAOs[t.attributeOrder] = this.gl.renderer.createVertexArray(), this.gl.renderer.bindVertexArray(this.VAOs[t.attributeOrder]), this.bindAttributes(t);
  }
  /**
   * Binds all attributes as derived from the program to attribute objects supplied to the geometry
   * @param {Program} program - The program to use to determine attribute locations
   */
  bindAttributes(t) {
    t.attributeLocations.forEach((e, { name: s, type: r }) => {
      if (!this.attributes[s]) {
        console.warn(`active attribute ${s} not being supplied`);
        return;
      }
      const a = this.attributes[s];
      this.gl.bindBuffer(a.target, a.buffer), this.gl.renderer.state.boundBuffer = a.buffer;
      let n = 1;
      r === 35674 && (n = 2), r === 35675 && (n = 3), r === 35676 && (n = 4);
      const u = a.size / n, o = n === 1 ? 0 : n * n * 4, h = n === 1 ? 0 : n * 4;
      for (let l = 0; l < n; l++)
        this.gl.vertexAttribPointer(
          e + l,
          u,
          a.type,
          a.normalized,
          a.stride + o,
          a.offset + l * h
        ), this.gl.enableVertexAttribArray(e + l), this.gl.renderer.vertexAttribDivisor(e + l, a.divisor);
    }), this.attributes.index && this.gl.bindBuffer(
      this.gl.ELEMENT_ARRAY_BUFFER,
      this.attributes.index.buffer
    );
  }
  bindTransformFeedbacks() {
    const t = (this.transformFeedbackIndex + 1) % 2, e = this.transformFeedbacks.VAOs[this.transformFeedbackIndex], s = this.transformFeedbacks.TFBs[t], r = this.transformFeedbacks.BufferRefs[t];
    this.gl.bindVertexArray(e), this.gl.bindTransformFeedback(this.gl.TRANSFORM_FEEDBACK, s), window.feedbk = s;
    for (const a in r) {
      const n = r[a];
      this.gl.bindBufferBase(this.gl.TRANSFORM_FEEDBACK_BUFFER, n.i, n.buffer);
    }
    this.transformFeedbackIndex = t;
  }
  /**
   * Draw the geometry
   * @param {Object} __namedParameters - The parameters to be used for the draw command
   * @param {Program} program - The Program object to draw to
   * @param {GLenum} mode - The mode to draw the object in
   */
  draw({
    program: t,
    mode: e = this.gl.TRIANGLES
  }) {
    this.gl.renderer.currentGeometry !== `${this.id}_${t.attributeOrder}` && (this.VAOs[t.attributeOrder] || this.createVAO(t), this.gl.renderer.bindVertexArray(this.VAOs[t.attributeOrder]), this.gl.renderer.currentGeometry = `${this.id}_${t.attributeOrder}`), window.transformFeedbacks = this.transformFeedbacks, this.transformFeedbacks && (this.bindTransformFeedbacks(), this.gl.beginTransformFeedback(e)), t == null || t.attributeLocations.forEach((s, { name: r }) => {
      const a = this.attributes[r];
      a && a.needsUpdate && a.updateAttribute(this.gl);
    }), this.isInstanced ? this.attributes.index ? this.gl.renderer.drawElementsInstanced(
      e,
      this.drawRange.count,
      this.attributes.index.type,
      this.attributes.index.offset + this.drawRange.start * 2,
      this.instancedCount
    ) : this.gl.renderer.drawArraysInstanced(
      e,
      this.drawRange.start,
      this.drawRange.count,
      this.instancedCount
    ) : this.attributes.index ? this.gl.drawElements(
      e,
      this.drawRange.count,
      this.attributes.index.type,
      this.attributes.index.offset + this.drawRange.start * 2
    ) : this.gl.drawArrays(e, this.drawRange.start, this.drawRange.count), this.transformFeedbacks && this.gl.endTransformFeedback();
  }
  /**
   * Returns the position atribute array
   * @returns {WTCGLGeometryAttribute}
   */
  getPosition() {
    const t = this.attributes.position;
    if (t.data)
      return t;
    gt || (gt = !0, console.warn("No position buffer data found to compute bounds"));
  }
  /**
   * Computes the bounding box of the geometry. If no attribute is provided to compue with, try to use the position attribute array by default.
   * @param {WTCGLGeometryAttribute} attr - The attribute array to compute the bounding box off
   */
  computeBoundingBox(t) {
    t || (t = this.getPosition());
    const e = t.data, s = t.offset || 0, r = t.stride || t.size;
    this.bounds || (this.bounds = {
      min: new p(),
      max: new p(),
      center: new p(),
      scale: new p(),
      radius: 1 / 0
    });
    const a = this.bounds.min, n = this.bounds.max, u = this.bounds.center, o = this.bounds.scale;
    a.reset(1 / 0, 1 / 0, 1 / 0), n.reset(-1 / 0, -1 / 0, -1 / 0);
    for (let h = s, l = e.length; h < l; h += r) {
      const c = e[h], f = e[h + 1], g = e[h + 2];
      a.x = Math.min(c, a.x), a.y = Math.min(f, a.y), a.z = Math.min(g, a.z), n.x = Math.max(c, n.x), n.y = Math.max(f, n.y), n.z = Math.max(g, n.z);
    }
    o.resetToVector(n.subtractNew(a)), u.resetToVector(a.addNew(n).scale(0.5));
  }
  /**
   * Computes the bounding sphere of the geometry. If no attribute is provided to compue with, try to use the position attribute array by default.
   * @param {WTCGLGeometryAttribute} attr - The attribute array to compute the bounding box off
   */
  computeBoundingSphere(t) {
    t || (t = this.getPosition());
    const e = t.data, s = t.offset || 0, r = t.stride || t.size;
    this.bounds || this.computeBoundingBox(t);
    let a = 0;
    for (let n = s, u = e.length; n < u; n += r) {
      const o = Dt(e, n);
      a = Math.max(
        a,
        this.bounds.center.subtractNew(o).lengthSquared
      );
    }
    this.bounds.radius = Math.sqrt(a);
  }
  /**
   * Remoce all of the vertex array objects and buffers from memory
   */
  remove() {
    for (const t in this.VAOs)
      this.gl.renderer.deleteVertexArray(this.VAOs[t]), delete this.VAOs[t];
    for (const t in this.attributes)
      this.gl.deleteBuffer(this.attributes[t].buffer), delete this.attributes[t];
  }
}
class L {
  /**
   * Create a geometry attribute
   * @param {Object} __namedParameters - The parameters for the attribute
   * @param {number} size - The size of the attribute elements, this will determine the type of attribute in the shader.
   * @param {number} stride - How many bytes to stride by in instances of combined attributes
   * @param {number} offset - How many bytes to offset the attribute.
   * @param {number} instanced - The number of instances this attribute has
   * @param {GLenum} type - FLOAT, UNSIGNED_SHORT, or UNSIGNED_INT
   * @param {boolean} normalized - whether integer data values should be normalized into a certain range when being cast to a float.
   */
  constructor({
    size: t = 1,
    stride: e = 0,
    offset: s = 0,
    instanced: r = 0,
    count: a,
    type: n,
    normalized: u = !1,
    data: o
  }) {
    /**
     * The size of each element in the attribute. For example if you're describing 3D vectors, this would be 3.
     * */
    i(this, "size", 1);
    /**
     * How big a stride should this attribute have. Should be 0 for all attributes that are uncombined.
     */
    i(this, "stride", 0);
    /**
     * How many bytes to offset when passing in the buffer
     */
    i(this, "offset", 0);
    /**
     * the number of elements in the attribute
     */
    i(this, "count");
    /**
     * The divisor, used in instanced attributes
     */
    i(this, "divisor", 0);
    /**
     * The number of instances for this attribute
     */
    i(this, "instanced");
    /**
     * A typed array of data for the attribute
     */
    i(this, "data");
    /**
     * The WebGL buffer containing the static attribute data
     */
    i(this, "buffer");
    /**
     * default gl.UNSIGNED_SHORT for 'index', gl.FLOAT for others
     */
    i(this, "type");
    /**
     * gl.ELEMENT_ARRAY_BUFFER or gl.ARRAY_BUFFER depending on whether this is an index attribute or not
     */
    i(this, "target");
    /**
     * whether integer data values should be normalized into a certain range when being cast to a float.
     */
    i(this, "normalized");
    /**
     * whether this attribute needs an update. Set after the attribute changes to have it recast to memory
     */
    i(this, "needsUpdate", !1);
    this.size = t, this.stride = e, this.offset = s, this.instanced = r, this.data = o, this.type = n || (this.data.constructor === Float32Array ? window.WebGLRenderingContext.FLOAT : this.data.constructor === Uint16Array ? window.WebGLRenderingContext.UNSIGNED_SHORT : window.WebGLRenderingContext.UNSIGNED_INT), this.normalized = u, this.count = a || e ? o.byteLength / e : o.length / t, this.divisor = r || 0;
  }
  /**
   * Udpate an attribute for rendering
   * @param {WTCGLRenderingContext} gl - The WTCGL rendering context.
   */
  updateAttribute(t) {
    t.renderer.state.boundBuffer !== this.buffer && (t.bindBuffer(this.target, this.buffer), t.renderer.state.boundBuffer = this.buffer), t.bufferData(this.target, this.data, t.STATIC_DRAW), this.needsUpdate = !1;
  }
}
class Ut extends it {
  constructor(t, { attributes: e = {} } = {}) {
    Object.assign(e, {
      position: new L({
        size: 2,
        data: new Float32Array([-1, -1, 3, -1, -1, 3])
      }),
      uv: new L({
        size: 2,
        data: new Float32Array([0, 0, 2, 0, 0, 2])
      })
    }), super(t, e);
  }
}
class B extends it {
  constructor(t, {
    width: e = 1,
    height: s = 1,
    widthSegments: r = 1,
    heightSegments: a = 1,
    attributes: n = {}
  } = {}) {
    const u = r, o = a, h = (u + 1) * (o + 1), l = u * o * 6, c = new Float32Array(h * 3), f = new Float32Array(h * 3), g = new Float32Array(h * 2), x = l > 65536 ? new Uint32Array(l) : new Uint16Array(l);
    B.buildPlane(
      c,
      f,
      g,
      x,
      e,
      s,
      0,
      u,
      o
    );
    const m = Object.assign({}, n, {
      position: new L({ size: 3, data: c }),
      normal: new L({ size: 3, data: f }),
      uv: new L({ size: 2, data: g }),
      index: new L({ data: x })
    });
    super(t, m);
  }
  static buildPlane(t, e, s, r, a, n, u, o, h, l = 0, c = 1, f = 2, g = 1, x = -1, m = 0, T = 0) {
    const _ = m, E = a / o, w = n / h;
    for (let b = 0; b <= h; b++) {
      const I = b * w - n / 2;
      for (let v = 0; v <= o; v++, m++) {
        const P = v * E - a / 2;
        if (t[m * 3 + l] = P * g, t[m * 3 + c] = I * x, t[m * 3 + f] = u / 2, e[m * 3 + l] = 0, e[m * 3 + c] = 0, e[m * 3 + f] = u >= 0 ? 1 : -1, s[m * 2] = v / o, s[m * 2 + 1] = 1 - b / h, b === h || v === o)
          continue;
        const _t = _ + v + b * (o + 1), ot = _ + v + (b + 1) * (o + 1), vt = _ + v + (b + 1) * (o + 1) + 1, lt = _ + v + b * (o + 1) + 1;
        r[T * 6] = _t, r[T * 6 + 1] = ot, r[T * 6 + 2] = lt, r[T * 6 + 3] = ot, r[T * 6 + 4] = vt, r[T * 6 + 5] = lt, T++;
      }
    }
  }
}
class jt extends it {
  constructor(t, {
    width: e = 1,
    height: s = 1,
    depth: r = 1,
    widthSegments: a = 1,
    heightSegments: n = 1,
    depthSegments: u = 1,
    attributes: o = {}
  } = {}) {
    const h = a, l = n, c = u, f = (h + 1) * (l + 1) * 2 + (h + 1) * (c + 1) * 2 + (l + 1) * (c + 1) * 2, g = (h * l * 2 + h * c * 2 + l * c * 2) * 6, x = new Float32Array(f * 3), m = new Float32Array(f * 3), T = new Float32Array(f * 2), _ = f > 65536 ? new Uint32Array(g) : new Uint16Array(g);
    let E = 0, w = 0;
    B.buildPlane(
      x,
      m,
      T,
      _,
      r,
      s,
      e,
      c,
      l,
      2,
      1,
      0,
      -1,
      -1,
      E,
      w
    ), E += (c + 1) * (l + 1), w += c * l, B.buildPlane(
      x,
      m,
      T,
      _,
      r,
      s,
      -e,
      c,
      l,
      2,
      1,
      0,
      1,
      -1,
      E,
      w
    ), E += (c + 1) * (l + 1), w += c * l, B.buildPlane(
      x,
      m,
      T,
      _,
      e,
      r,
      s,
      c,
      h,
      0,
      2,
      1,
      1,
      1,
      E,
      w
    ), E += (h + 1) * (c + 1), w += h * c, B.buildPlane(
      x,
      m,
      T,
      _,
      e,
      r,
      -s,
      c,
      h,
      0,
      2,
      1,
      1,
      -1,
      E,
      w
    ), E += (h + 1) * (c + 1), w += h * c, B.buildPlane(
      x,
      m,
      T,
      _,
      e,
      s,
      -r,
      h,
      l,
      0,
      1,
      2,
      -1,
      -1,
      E,
      w
    ), E += (h + 1) * (l + 1), w += h * l, B.buildPlane(
      x,
      m,
      T,
      _,
      e,
      s,
      r,
      h,
      l,
      0,
      1,
      2,
      1,
      -1,
      E,
      w
    );
    const b = Object.assign({}, o, {
      position: new L({ size: 3, data: x }),
      normal: new L({ size: 3, data: m }),
      uv: new L({ size: 2, data: T }),
      index: new L({ data: _ })
    });
    super(t, b);
  }
}
class Ct extends it {
  constructor(t, {
    particles: e = 128,
    dimensions: s = 3,
    fillFunction: r = (u, o) => {
      for (let h = 0; h < u.length; h += o)
        for (let l = 0; l < o; l++)
          u[h + l] = Math.random();
    },
    attributes: a = {},
    transformFeedbacks: n
  } = {}) {
    const u = new Float32Array(e * s).fill(0);
    r(u, s);
    const o = Object.assign({}, a, {
      position: new L({ size: s, data: u })
    });
    super(t, o, n);
  }
}
var U, D, W, j, C, G, Y, H;
const R = class R {
  constructor(t, {
    name: e = "FBO",
    width: s = 512,
    height: r = 512,
    dpr: a = Math.min(window.devicePixelRatio, 2),
    tiling: n = R.IMAGETYPE_REGULAR,
    texdepth: u = R.TEXTYPE_UNSIGNED_BYTE,
    minFilter: o = t.LINEAR,
    magFilter: h = o,
    premultiplyAlpha: l = !1,
    data: c = null,
    depth: f = !0
  } = {}) {
    i(this, "gl");
    i(this, "name");
    i(this, "depth");
    S(this, U, void 0);
    S(this, D, void 0);
    S(this, W, void 0);
    S(this, j, void 0);
    S(this, C, void 0);
    S(this, G, R.IMAGETYPE_REGULAR);
    S(this, Y, R.TEXTYPE_UNSIGNED_BYTE);
    S(this, H, void 0);
    i(this, "minFilter");
    i(this, "magFilter");
    i(this, "premultiplyAlpha");
    this.gl = t, this.name = e, this.dpr = a, this.tiling = n, this.texdepth = u, this.data = c, this.depth = f, this.minFilter = o, this.magFilter = h, this.premultiplyAlpha = l, this.resize(s, r);
  }
  resize(t, e) {
    this.width = t, this.height = e, y(this, U, this.createFrameBuffer()), y(this, D, this.createFrameBuffer());
  }
  createFrameBuffer() {
    const e = this.type === this.gl.FLOAT ? this.gl.RGBA32F : this.gl.RGBA;
    return new Lt(this.gl, {
      data: this.data,
      width: this.width * this.dpr,
      height: this.height * this.dpr,
      minFilter: this.minFilter,
      magFilter: this.magFilter,
      wrapS: this.wrap,
      wrapT: this.wrap,
      type: this.type,
      internalFormat: e,
      premultiplyAlpha: this.premultiplyAlpha,
      depth: this.depth
    });
  }
  swap() {
    const t = A(this, U);
    y(this, U, A(this, D)), y(this, D, t);
  }
  render(t, { scene: e, camera: s, update: r = !0, clear: a, viewport: n }) {
    t.render({
      scene: e,
      camera: s,
      target: A(this, D),
      update: r,
      clear: a,
      viewport: n
    }), this.swap();
  }
  get wrap() {
    switch (A(this, G)) {
      case R.IMAGETYPE_REGULAR:
        return this.gl.CLAMP_TO_EDGE;
      case R.IMAGETYPE_TILING:
        return this.gl.MIRRORED_REPEAT;
      case R.IMAGETYPE_MIRROR:
        return this.gl.REPEAT;
    }
  }
  get type() {
    switch (A(this, Y)) {
      case R.TEXTYPE_FLOAT:
        return this.gl.FLOAT;
      case R.TEXTYPE_UNSIGNED_BYTE:
        return this.gl.UNSIGNED_BYTE;
      case R.TEXTYPE_HALF_FLOAT_OES: {
        const t = this.gl.getExtension("OES_texture_half_float");
        return (t == null ? void 0 : t.HALF_FLOAT_OES) || this.gl.HALF_FLOAT;
      }
    }
  }
  get read() {
    return A(this, U);
  }
  get write() {
    return A(this, D);
  }
  set data(t) {
    t instanceof Float32Array && y(this, H, t);
  }
  get data() {
    return A(this, H) || null;
  }
  set width(t) {
    t > 0 && y(this, W, t);
  }
  get width() {
    return A(this, W) || 1;
  }
  set height(t) {
    t > 0 && y(this, j, t);
  }
  get height() {
    return A(this, j) || 1;
  }
  set pxRatio(t) {
    t > 0 && y(this, C, t);
  }
  get pxRatio() {
    return A(this, C) || 1;
  }
  set dpr(t) {
    t > 0 && y(this, C, t);
  }
  get dpr() {
    return A(this, C) || 1;
  }
  set tiling(t) {
    [
      R.IMAGETYPE_REGULAR,
      R.IMAGETYPE_TILING,
      R.IMAGETYPE_MIRROR
    ].indexOf(t) > -1 && y(this, G, t);
  }
  get tiling() {
    return A(this, G);
  }
  set texdepth(t) {
    [
      R.TEXTYPE_FLOAT,
      R.TEXTYPE_UNSIGNED_BYTE,
      R.TEXTYPE_HALF_FLOAT_OES
    ].indexOf(t) > -1 && y(this, Y, t);
  }
  get texdepth() {
    return A(this, Y);
  }
};
U = new WeakMap(), D = new WeakMap(), W = new WeakMap(), j = new WeakMap(), C = new WeakMap(), G = new WeakMap(), Y = new WeakMap(), H = new WeakMap(), i(R, "TEXTYPE_FLOAT", 0), i(R, "TEXTYPE_UNSIGNED_BYTE", 1), i(R, "TEXTYPE_HALF_FLOAT_OES", 2), i(R, "IMAGETYPE_REGULAR", 0), i(R, "IMAGETYPE_TILING", 1), i(R, "IMAGETYPE_MIRROR", 2);
let Et = R;
var zt = `precision highp float;

uniform vec2 u_resolution;
uniform float u_time;
uniform vec2 u_mouse;
uniform sampler2D s_noise;

uniform sampler2D b_noise;

varying vec2 v_uv;

void main() {
  gl_FragColor = vec4(vec3(cos(length(v_uv+u_time))*.5+.5, sin(v_uv+u_time)*.5+.5),1);
}`, kt = `attribute vec3 position;
attribute vec2 uv;

varying vec2 v_uv;

void main() {
  gl_Position = vec4(position, 1.0);
  v_uv = uv;
}`;
const nt = typeof window < "u";
var q, z;
class Ht {
  constructor({
    vertex: t = kt,
    fragment: e = zt,
    dimensions: s = nt ? new M(window.innerWidth, window.innerHeight) : new M(500, 500),
    container: r = document.body,
    autoResize: a = !0,
    uniforms: n = {},
    onInit: u = () => {
    },
    onBeforeRender: o = () => {
    },
    onAfterRender: h = () => {
    },
    rendererProps: l = {}
  } = {}) {
    i(this, "uniforms");
    i(this, "dimensions");
    i(this, "autoResize", !0);
    i(this, "onBeforeRender");
    i(this, "onAfterRender");
    i(this, "u_time");
    i(this, "u_resolution");
    i(this, "gl");
    i(this, "renderer");
    i(this, "program");
    i(this, "mesh");
    i(this, "lastTime", 0);
    S(this, q, void 0);
    S(this, z, !1);
    this.onBeforeRender = o.bind(this), this.onAfterRender = h.bind(this), this.render = this.render.bind(this), this.resize = this.resize.bind(this), this.autoResize = a, this.dimensions = s, this.u_time = new N({ name: "time", value: 0, kind: "float" }), this.u_resolution = new N({
      name: "resolution",
      value: this.dimensions.array,
      kind: "float_vec2"
    }), this.uniforms = Object.assign({}, n, {
      u_time: this.u_time,
      u_resolution: this.u_resolution
    }), this.renderer = new bt(l), u(this.renderer), this.gl = this.renderer.gl, r.appendChild(this.gl.canvas), this.gl.clearColor(1, 1, 1, 1), this.autoResize && nt ? (window.addEventListener("resize", this.resize, !1), this.resize()) : (this.renderer.dimensions = s, this.u_resolution.value = this.dimensions.scaleNew(
      this.renderer.dpr
    ).array);
    const c = new Ut(this.gl);
    this.program = new xt(this.gl, {
      vertex: t,
      fragment: e,
      uniforms: this.uniforms
    }), this.mesh = new ht(this.gl, { geometry: c, program: this.program }), this.playing = !0;
  }
  resize() {
    this.dimensions = nt ? new M(window.innerWidth, window.innerHeight) : new M(500, 500), this.u_resolution.value = this.dimensions.scaleNew(this.renderer.dpr).array, this.renderer.dimensions = this.dimensions;
  }
  resetTime() {
    this.lastTime = 0;
  }
  render(t) {
    const e = t - this.lastTime;
    this.lastTime = t, this.playing && requestAnimationFrame(this.render);
    const s = this.u_time.value;
    this.u_time.value = s + e * 5e-5, this.onBeforeRender(t), this.post ? this.post.render(this.renderer, { scene: this.mesh }) : this.renderer.render({ scene: this.mesh }), this.onAfterRender(t);
  }
  set post(t) {
    y(this, q, t);
  }
  get post() {
    return A(this, q) || null;
  }
  set playing(t) {
    A(this, z) !== !0 && t === !0 ? (requestAnimationFrame(this.render), y(this, z, !0)) : t == !1 && (this.lastTime = 0, y(this, z, !1));
  }
  get playing() {
    return A(this, z) === !0;
  }
}
q = new WeakMap(), z = new WeakMap();
var Gt = `#extension GL_OES_standard_derivatives : enable
precision highp float;

uniform vec2 u_resolution;
uniform vec2 u_mouse;
uniform float u_time;

varying vec3 v_colour;

void main() {
  vec2 uv = gl_PointCoord.xy - .5;

  gl_FragColor = vec4(0, 0, 0, 1);

  float l = length(uv);
  float c = smoothstep(.5, 0., l);
  float opacity = c;

  gl_FragColor = vec4(v_colour, 1.);
}`, Yt = `attribute vec2 reference;
attribute vec2 position;
attribute float property;

uniform vec2 u_resolution;
uniform vec2 u_screen;

uniform sampler2D b_velocity;
uniform sampler2D b_position;

varying vec3 v_colour;
varying float v_fogDepth;

void main() {
  vec2 position = texture2D(b_position, reference).xy;
  gl_PointSize = 2.;
  vec2 p = position/u_resolution;
  v_colour = property == 1. ? vec3(1,0,0) : vec3(1,1,1);
  vec4 pos = vec4(position / u_resolution * 2. - 1., 0., 1.);
  gl_Position = vec4(pos.xy, 0., 1.);
}`;
const at = typeof window < "u";
var Z, k, $, K, Q, J, tt, et;
class qt {
  constructor({
    vertex: t = Yt,
    fragment: e = Gt,
    dimensions: s = at ? new M(window.innerWidth, window.innerHeight) : new M(500, 500),
    container: r = document.body,
    autoResize: a = !0,
    uniforms: n = {},
    onBeforeRender: u = () => {
    },
    onAfterRender: o = () => {
    },
    textureSize: h = 128,
    simDimensions: l = 3,
    createGeometry: c,
    rendererProps: f = {}
  } = {}) {
    i(this, "uniforms");
    i(this, "dimensions");
    i(this, "autoResize", !0);
    i(this, "onBeforeRender");
    i(this, "onAfterRender");
    i(this, "u_time");
    i(this, "u_resolution");
    i(this, "gl");
    i(this, "renderer");
    i(this, "program");
    i(this, "mesh");
    i(this, "textureSize");
    i(this, "particles");
    i(this, "textureArraySize");
    i(this, "simDimensions");
    i(this, "references");
    i(this, "cloud");
    i(this, "lastTime", 0);
    S(this, Z, void 0);
    S(this, k, !1);
    // Getters and setters for renderer
    S(this, $, void 0);
    S(this, K, !0);
    S(this, Q, !0);
    S(this, J, !0);
    S(this, tt, void 0);
    S(this, et, void 0);
    this.onBeforeRender = u.bind(this), this.onAfterRender = o.bind(this), this.render = this.render.bind(this), this.resize = this.resize.bind(this), this.autoResize = a, this.dimensions = s, this.u_time = new N({ name: "time", value: 0, kind: "float" }), this.u_resolution = new N({
      name: "resolution",
      value: this.dimensions.array,
      kind: "float_vec2"
    }), this.uniforms = Object.assign({}, n, {
      u_time: this.u_time,
      u_resolution: this.u_resolution
    }), this.renderer = new bt(f), this.gl = this.renderer.gl, this.gl.clearColor(0, 0, 0, 1), this.autoResize && at ? (window.addEventListener("resize", this.resize, !1), this.resize()) : this.renderer.dimensions = s, this.textureSize = h, this.particles = Math.pow(this.textureSize, 2), this.textureArraySize = this.particles * 4, this.simDimensions = l, this.references = new Float32Array(this.particles * 2).fill(0), c && typeof c == "function" ? c.bind(this)() : this.createGeometry(), this.program = new xt(this.gl, {
      vertex: t,
      fragment: e,
      uniforms: this.uniforms
    }), this.mesh = new ht(this.gl, {
      mode: this.gl.POINTS,
      geometry: this.cloud,
      program: this.program
    }), this.playing = !0, r.appendChild(this.gl.canvas);
  }
  createGeometry() {
    this.cloud = new Ct(this.gl, {
      fillFunction: (t, e) => {
        for (let s = 0; s < t.length; s += 2) {
          const r = s / 2, a = new M(
            r % this.textureSize,
            Math.floor(r / this.textureSize)
          );
          this.references[s] = a.x / this.textureSize, this.references[s + 1] = a.y / this.textureSize;
        }
        for (let s = 0; s < t.length; s += e)
          for (let r = 0; r < e; r++)
            t[s + r] = Math.random() * 400 - 200;
      },
      particles: this.particles,
      dimensions: this.simDimensions,
      attributes: {
        reference: new L({ size: 2, data: this.references })
      }
    });
  }
  render(t) {
    const e = t - this.lastTime;
    this.lastTime = t, this.playing && requestAnimationFrame(this.render);
    const s = this.u_time.value;
    this.u_time.value = s + e * 5e-5, this.onBeforeRender(t), this.post ? this.post.render(this.renderer, {
      scene: this.mesh,
      camera: this.camera,
      update: this.update,
      sort: this.sort,
      frustumCull: this.frustumCull,
      clear: this.clear,
      viewport: this.viewport
    }) : this.renderer.render({
      scene: this.mesh,
      camera: this.camera,
      update: this.update,
      sort: this.sort,
      frustumCull: this.frustumCull,
      clear: this.clear,
      viewport: this.viewport
    }), this.onAfterRender(t);
  }
  resize() {
    this.dimensions = at ? new M(window.innerWidth, window.innerHeight) : new M(500, 500), this.u_resolution.value = this.dimensions.scaleNew(this.renderer.dpr).array, this.renderer.dimensions = this.dimensions;
  }
  set post(t) {
    y(this, Z, t);
  }
  get post() {
    return A(this, Z) || null;
  }
  set playing(t) {
    A(this, k) !== !0 && t === !0 ? (requestAnimationFrame(this.render), y(this, k, !0)) : t == !1 && y(this, k, !1);
  }
  get playing() {
    return A(this, k) === !0;
  }
  set camera(t) {
    (t == null || t instanceof Tt) && y(this, $, t);
  }
  get camera() {
    return A(this, $);
  }
  set update(t) {
    y(this, K, t === !0);
  }
  get update() {
    return A(this, K);
  }
  set sort(t) {
    y(this, Q, t === !0);
  }
  get sort() {
    return A(this, Q);
  }
  set frustumCull(t) {
    y(this, J, t === !0);
  }
  get frustumCull() {
    return A(this, J);
  }
  set clear(t) {
    y(this, tt, t === !0);
  }
  get clear() {
    return A(this, tt);
  }
  set viewport(t) {
    (t instanceof Array && t[0] instanceof M && t[1] instanceof M || t == null) && y(this, et, t);
  }
  get viewport() {
    return A(this, et);
  }
}
Z = new WeakMap(), k = new WeakMap(), $ = new WeakMap(), K = new WeakMap(), Q = new WeakMap(), J = new WeakMap(), tt = new WeakMap(), et = new WeakMap();
export {
  jt as Box,
  Tt as Camera,
  mt as DollyCamera,
  wt as Drawable,
  Ht as FragmentShader,
  Et as Framebuffer,
  it as Geometry,
  L as GeometryAttribute,
  ht as Mesh,
  At as Obj,
  qt as ParticleSimulation,
  B as Plane,
  Ct as PointCloud,
  xt as Program,
  Lt as RenderTarget,
  bt as Renderer,
  V as Texture,
  Wt as TransformFeedback,
  Ut as Triangle,
  N as Uniform
};
